/** ******************************************************************************
 * @file    AT_Module.h
 * @author  δ DOIOT
 * @brief   Թ˾ģATָĴ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 ********************************************************************************/
#include "uint8_t.h"

#define Ask_arry_size     2
#define Ask_arry_len      100
//[Ask_arry_size][Ask_arry_len]
typedef struct{
	
		/*͵ָ      */
		char *SEND_CMD;  		 
		/*ӦӦָ      */
    char *ASK[Ask_arry_len];  
		/*ҪУָ      */
		uint32_t crc_size;	
		/*ָȴʱʱ*/
	  uint32_t timeout; 		
		/*ط*/
		uint32_t REF_Count;		
		/*ʧʱҪתָλ*/
		uint32_t jump;			
		/*֧עһǰص*/
		void (*BeforeCpltCallback)();
		/*֧עһУɻص,ĬΪrx_buff*/
		void (*AfterCpltCallback)(char *rx_buff);
		/*֧עһУ麯,ĬΪrx_buff*/
		void (*ErrorCpltCallback)(char *rx_buff);
		/*ɺʱ*/
		uint32_t delay_time;
	
}AT_CMD;  /*ָṹ*/

/**@brief ʼAT*/
uint8_t AT_TASK_START(AT_CMD task[],uint8_t Size);

#define cmd_length			256				/*Ӧָ󳤶*/
/**@brief ȡУ*/
uint8_t Module_SEND_CRC(char* send_cmd,char *ack_str,uint32_t overtime);
/**@brief ȡУ,ֶ֧*/
uint8_t Module_SEND_A_CRC(char* send_cmd,char cmd_arry[][cmd_length],uint8_t arry_size,uint8_t crc_size);
/**@brief ȡУ*/
uint8_t Module_Read_A_CRC(char cmd_arry[],uint32_t overtime);
/**@brief ѯ,Уɹ󷵻*/
uint8_t AT_CMD_Polling(char *send_cmd,char*ack,uint32_t Polling_delay,uint32_t overtime);

/*-ַ------ɰ桿---------------------------------------------------------------------------------*/

/**@brief ַΪ־ȡӴ*/
uint8_t AT_GET_Data(char * buff,uint8_t * get_data,char*sign,uint8_t Number_of_groups);
/**@brief ӴΪ־ȡӴ*/
uint8_t AT_GET_Data_2Param(char * buff,uint8_t get_data[],char*head,char*tail);
/**@brief ѱ־λӴ滻ΪҪ滻Ӵ*/
uint8_t AT_Data_Replace(char buff[],char *str1, char *str2);
/**@brief AT_GET_Data_Param_number :ָı־λʼȡݣֱ\r,\n,*/
uint8_t AT_GET_Data_Param(char * buff,uint8_t get_data[],char*head);

/**@brief AT_Extract_numbers:ѵᴿΪ*/
uint8_t AT_Extract_numbers(char buff[]);
/**@brief AT_Extract_numbers :ᴿΪַ*/
uint8_t AT_Extract_numbers_letters(char buff[]);
/**@brief AT_Remove_spaces :ȥַ,\r,\n,space */
uint8_t AT_Remove_spaces(char buff[]);


/*---------------------------ⲿûC׼----------------------------------------------*/

int 	 my_strlen (const char *s) ;
char 	*my_strstr(const char *str, const char *sub_str);
char	*my_strcpy(char*dest, const char*src);
char  *my_strcat(char*dest, const char*src);


/**@brief Եظ־ʼλͽλ־ȡ*/
char*		 	GetString_StartEnd(char * src,char *dest,char*sign,uint8_t start,uint8_t end);
/**@brief ִΪ־ȡĲ*/
uint8_t 	GetString_Wrapped(char * src,char *dest,char*start_str,char* end_str);
/**@brief ַ滻*/
uint8_t   ReplaceString(char * src,char*bereplaced,char* replace);
/**@brief 滻ַеĿո,\r,\n*/
uint8_t   ReplaceSpace(char * src);

