/** ******************************************************************************
 * @file    uart_framework.h
 * @author  
 * @brief   halĴڿ
 ******************************************************************************
 * @attention
 * 2021/1/10
 * 
 * ע:Ϊcubemxɵhalṩٿ4GģAPI;
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾1.0		˳ṹ
 ********************************************************************************/
  
#include "main.h"					 /* ṩcubemxɵmain.hļ */

#ifndef UART_PROCESS_H   
#define UART_PROCESS_H
 
typedef unsigned          char uint8_t;
typedef unsigned short     int uint16_t;
typedef unsigned           int uint32_t;

/* 

ò裺

ѭ 									UartCoreLoop();						Ĳںˡ

ڼʱжУƼδ  UartCoreTick();   				ںеʱ

RXصУ				  UartCoreRxIT(huart);			ںﲶ

*/

typedef struct 
{
	/*ʽӡָ*/
	void 		(*Printf)(const char *format, ...);
	/*ͺ*/
	void 		(*Send)(uint8_t *txbuf,uint32_t len);	
	/*ȡݣóʱʱ*/
	uint8_t (*BlockRead)(char rxbuf[],uint32_t overtime_ms);
	/*עϾɺ,úֻעһظעḲ*/
	void 		(*RegistPuncCallBack)(void (*CallTask)(uint8_t *cache,int length));
	/*עṳӺظעᣬ֧20*/
	uint8_t (*RegistHookCallBack)(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
	/*ⲿ˫*/
	void 		(*LoadCache)(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
	
}SerialCore,*SerialCoreHand;

/*-------------------------------------------------ŵAPI------------------------------------------------------------------*/
/*ļܹʵ*/

/*еʱ*/
void UartCoreTick(void);
	
/*ĵĽж*/
void UartCoreRxIT(void *huart);
	
/*ںѯ*/
uint8_t UartCoreLoop(void);
/*---------------------------------------*/
/*API*/

/*ľһ*/
void UartCoreBind(SerialCoreHand uartcore,void *huart);

/*printfջ*/
void 	SetPrintStack(uint32_t size);

/*һӿӦdebug,Ϊģ*/
void 	SetDebugSerial(void *debugSerial);

/*һӿ֧module,Ϊģ*/
void 	SetModuleSerial(void *moduleSerial);

/*һcoreΪmoduleʹõĴ,Ϊģ*/
uint8_t SetCoreIsModule(SerialCoreHand hand);


/*apiṩ4Gģ飬Ϊײ*/
uint8_t Module_Blocking_Read(char rxbuf[],uint32_t overtime_ms);				/*ģȡ*/
void 		debug_printf(const char *format, ...);													/*Դӡ*/
void 		module_printf(const char *format, ...);	
uint8_t Module_Blocking_Read_P(char rxbuf[],uint32_t overtime_ms,uint8_t (*Task)(void));


/*-------------------------------------------------ĹAPI------------------------------------------------------------------*/

#define 	FOREVER					0

/*עһʱ񣬲Ϊʱ msҪѵĺǷʵʱһᱻģṩһڵĹ*/
uint8_t 	TimedTaskRegister(uint32_t timing,uint8_t (*timeTask)(void));
/*ʱ񣬲:ܻѴ0ΪԶִ*/
uint8_t 	TimeTaskStart(uint8_t (*timeTask)(),uint32_t countnumber);


/*ģ鳤charĺ*/
#define 	rxbuff(name)  				 			 char(name)[256]={0}; memset(name,0,256)
#define 	clear(name)								   memset(name,0,256)


#define 	DoubleCache(cache1,cache2,size) 		uint8_t (cache1)[(size)]={0};uint8_t (cache2)[(size)]={0}

#define configINFOPRINTF   0
#if(configINFOPRINTF)    /*δʹǿպ*/
/*ӡϢĺ*/														
#define 	info(format,...)  	 	debug_printf("\r\n>> "format"\r\n",##__VA_ARGS__)  
#else
#define 	info(format,...)  	 	{}
#endif

#define  	error(format,...)  	 debug_printf("\r\n[error]>>"format"\r\n",##__VA_ARGS__)
//#define error(format,...)		 debug_printf("\r\n[error] %s() %d >>"format"\r\n",__func__,__LINE__,##__VA_ARGS__)		
/*ӡ*/
#define   print(format,...)		 debug_printf(format, ##__VA_ARGS__)


/*ʮƴӡ*/
#define   print_string(s)				{debug_printf("\r\n");debug_printf("%s:[%s]",#s,s);debug_printf("\r\n");}
/*ʮƴӡ*/
#define   print_dec(s,len)				{debug_printf("\r\n");debug_printf("%s:",#s);for(int i=0;i<len;i++)debug_printf("[%d]",s[i]);	debug_printf("\r\n");}
/*16ƴӡ*/
#define   print_hex(s,len)				{debug_printf("\r\n");debug_printf("%s",#s);for(int i=0;i<len;i++)debug_printf("[0x%x]",s[i]);debug_printf("\r\n");}
/*floatӡ*/
#define   print_float(s,len)			{debug_printf("\r\n");debug_printf("%s",#s);for(int i=0;i<len;i++)debug_printf("[%f]",s[i]);debug_printf("\r\n");}
/*ascii ӡ*/
#define   print_ascii(s,len)			{debug_printf("\r\n");debug_printf("%s",#s);for(int i=0;i<len;i++)debug_printf("[%c]",s[i]);debug_printf("\r\n");}

#endif

void MyDelay(uint32_t time);

extern SerialCoreHand g_module_hand_support;

typedef void (*Handler)(uint8_t *cache,int length);
	
extern uint32_t  g_UartITCount;
