/********************************************************************************
 * @file    AT_Module.c
 * @author  δ DOIOT
 * @brief   Թ˾ģATָĴ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾1.3		ʱ2020/10/15   ļ֮϶
********************************************************************************/
/********************************************************************************
 * 21/1/5 : 
 * 1:ʼ޸ĲֺԽramʹ
********************************************************************************/


#include "serialport.h"
#include "at_module.h"
#include "stdarg.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"  


#define  SPACE_OR_TIME												1					/*ռʱģʽл*/



uint8_t AT_CMD_SEND(AT_CMD task);

uint8_t AT_TASK_START(AT_CMD task[],uint8_t Size)
{
	for(int i=0;i<Size;i++)
	{
		info("Start Task %d",i+1);

		if(AT_CMD_SEND(task[i]))
		{

			/*Уɹ,ʼʱ*/
			MyDelay(task[i].delay_time);	
		}
		else
		{

			/*Уʧ,ʼ*/
			if(task[i].REF_Count!=0)
			{
				task[i].REF_Count--;
				i--;/*һεصط*/
				info("ʼط");
			}
			else/*ûطߴѾ*/
			{
			/*װԾλ*/
				if(task[i].jump!=0)
				{
				i=task[i].jump-2;
				info("ʼת");
				}
			}
		}
	}
	return 1;
}

uint8_t AT_CMD_SEND(AT_CMD task)
{
	/*ִǰ*/
	if(task.BeforeCpltCallback!=NULL)
	{
		task.BeforeCpltCallback();
	}
		
	module_printf(task.SEND_CMD);
	info("SEND:%s",task.SEND_CMD);
	
	rxbuff(buff);
	
	uint8_t i=0;
	for(i=0;i<task.crc_size;i++)
	{

		Module_Blocking_Read(buff,task.timeout);
		info("ASK:%s",buff);
		
		if(strstr(buff,task.ASK[i]))
		{	
		}else
		{
			error("%s",buff);
			/*Уʧܣִʧܻص*/
			if(task.ErrorCpltCallback!=NULL)
			{
				task.ErrorCpltCallback(buff);
			}
			return 0;
		}
	}
		/*Уɹִɻص*/
	if(task.AfterCpltCallback!=NULL)
	{
		task.AfterCpltCallback(buff);
	}
		return 1;
}

/**
* @param sned_cmd	: ͵ָ
* @param cmd_arry	: ҪУӦ
* @param ack_str: ӦУִ
* @param overtime	: УӦ3У2ȡΣֻУ鵽2顿
*/

uint8_t Module_SEND_CRC(char* send_cmd,char *ack_str,uint32_t overtime)
{
	//char rxbuf[cmd_length];
	module_printf(send_cmd);
	if(Module_Read_A_CRC(ack_str,overtime)) return 1;//Уɹ;	
	else return 0;/*ĶȡһӦ,ʱʧ*/
}


/**
* @param sned_cmd	: ͵ָ
* @param cmd_arry	: ҪУӦ
* @param arry_size: ӦУ
* @param crc_size	: УӦ3У2ȡΣֻУ鵽2顿
*/

uint8_t Module_SEND_A_CRC(char* send_cmd,char cmd_arry[][cmd_length],uint8_t arry_size,uint8_t crc_size)
{
	char rxbuf[cmd_length];
	uint8_t i;
	module_printf(send_cmd);
	for(i=0;i<arry_size;i++)							/*ȡָ*/
	{	
		if(Module_Blocking_Read(rxbuf,1000));	/*ĶȡһӦ,ʱʧ*/
		else return 0;
			
		if(i<crc_size)												/*УָĴ*/
		{
			if(strstr(rxbuf,cmd_arry[i])) 
			{
			}else goto cmd_fail;
		}
	}
	return 1;//Уɹ
	
	cmd_fail: 
	{
		/*д*/
	}
	return  0;
}

/**
* @param ȡһݲУ
* @param cmd_arry	: ҪУӦ
* @param overtime	: ʱʱ
*/

uint8_t Module_Read_A_CRC(char cmd_arry[],uint32_t overtime)
{
	char rxbuf[cmd_length]={0};
	
	if(Module_Blocking_Read(rxbuf,overtime)) /*ĶȡһӦ,ʱʧ*/
	{
		if(strstr(rxbuf,cmd_arry))
		return 1;	
		else return 0;
	}
	else return 0;
}

/**@brief AT_CMD_Polling:ָָѯֱӦӦACKŷ
* @param  send_cmd			 : Ҫѯָ
* @param  Polling_fre	   : ѯ
* @param  overtime       : ʱʱ
*/
uint8_t AT_CMD_Polling(char *send_cmd,char*ack,uint32_t Polling_delay,uint32_t overtime)
{
	uint32_t time_count=0;
	while(1)
	{
		if(time_count%Polling_delay==0)
		{
		module_printf(send_cmd);
		if(Module_Read_A_CRC(ack,300)) return 1;
		}
		time_count++;
		MyDelay(1);
		if(time_count>overtime) return 0;
	}
}

/**@brief AT_GET_data:ȡַеNumber_of_groups鱻ضַϢ־ǳɶԱպϵ
* @param  buff			 : ȡַַ̬
* @param  get_data	 : ȡװص飬飬Ǿַ̬ΪҪд
* @param  sign       : ,һַ
* @param  Number_of_groups : ȡǵڼ
* ַ "AT+MIPOPEN=1,"TCP","122.114.122.174",41838,100,0,1,2,11002"
*			Number_of_groups=2ȡڶ飬װؽget_data: 122.114.122.174
*/
uint8_t AT_GET_Data(char * buff,uint8_t get_data[],char*sign,uint8_t Number_of_groups)
{
	uint16_t  i=0,count=0;
	while(buff[i]!='\0')				/*ȡָ*/
	{
	if(buff[i]==sign[0]) count++;
	i++;
	}
	if(count%2==0&&count>=Number_of_groups*2)							/*żָż*/
	{
		i=0;
		char chBuffer[512] ;				/**/
		char *pchDilem =sign;				/*ָ*/
		char *pchStrTmpIn = NULL;		/*ʣµĻ*/
		char *pchTmp = NULL;				/*ȡַ*/
		strcpy(chBuffer,buff);
		pchTmp = chBuffer;
		while(NULL != ( pchTmp = strtok_r( pchTmp, pchDilem, &pchStrTmpIn) ))
		{
		//	Uart1Printf("\n pchTmp[%s] \n",pchTmp);
			i++;
			if(i==Number_of_groups*2) strcpy((char*)get_data,pchTmp);
			pchTmp = NULL;
		}
		return 1;
	}
	else return 0;							/*żֱָӽ*/
}






/**@brief AT_GET_Data_2Param :ȡͷβִַ
* @param  buff			 : ȡַַ̬
* @param  get_data	 : ȡװص飬飬Ǿַ̬ΪҪд
* @param  head       : ͷַⳤȷ
* @param  tail			 : βַⳤַ
* ַ "+QGPSGNMEA: $GPRMC,021229.00,A,3041.560083,N,10405.832869,E,0.0,247.3,040920,1.9,W,A*28"
*			head ",A",tail ",N",װؽget_data: "3041.560083"
*/
uint8_t AT_GET_Data_2Param(char * buff,uint8_t get_data[],char*head,char*tail)
{
	if(strstr(buff,head)&&strstr(buff,tail))
	{
		uint16_t len1,len2;
		char *h=strstr(buff,head);
		len1=strlen(h);				/*ʣ೤*/	
		len2=strlen(head);		/*ͷӴ*/	
		char *t=strstr(h+len2,tail);
		uint16_t i;
		if(len1>len2)
		{
					for(i=0;h+i+len2!=t;i++)
					{
						get_data[i]=h[i+len2];	
					}
					get_data[i]='\0';//Ͻ
		}else 
		{
			debug_printf("\r\nִȴ\r\n");
			return 0;
		}
	}else
	{
		if(!strstr(buff,head))debug_printf("\r\nδܼͷִ\r\n");
		if(!strstr(buff,tail))debug_printf("\r\nδܼβִ\r\n");
		
		debug_printf("\r\nԭ:\r\n");
		debug_printf(buff);
		return 0;
	}
	return 1;
}



/**@brief AT_Data_Replace :ȡͷβִַ
* @param  buff			 : ȡַʵ飬Ҫд
* @param  str1	 		 : 滻Ӵ;ַ̬
* @param  str2       : 滻ɵӴ;ַ̬
* ַ AT+QMTCFG="aliauth",0,"a1XVq3z4DsR"
*			str1 "aliauth",str2 "recv/mode",滻buff: AT+QMTCFG="recv/mode",0,"a1XVq3z4DsR"
*/
uint8_t AT_Data_Replace(char buff[],char *str1, char *str2) {
    int i,flag = 0;
    char *p,*q,*ts;
    for(i = 0; buff[i]; ++i)
		{
						if(buff[i] == str1[0]) 
						{
								p = buff + i;
								q = str1;
								while(*q && (*p++ == *q++));
								if(*q == '\0') 
									{
										ts = (char *)malloc(strlen(buff) + 1);
										strcpy(ts,p);
										buff[i] = '\0';
										strcat(buff,str2);
										strcat(buff,ts);
										free(ts);
										flag = 1;
									}
						}
    }
    return flag;
}






/**@brief AT_GET_Data_Param_number :ָı־λʼȡݣֱ\r,\n,
* @param  buff			 : ȡַַ̬
* @param  get_data	 : ȡװص飬飬Ǿַ̬ΪҪд
* @param  head       : ͷַⳤȷ
* ַ "  +ESOERR=1,4   "
*			head ",",װؽget_data: "4"
*/
uint8_t AT_GET_Data_Param(char * buff,uint8_t get_data[],char*head)
{
	char *h=strstr(buff,head);
	if(h!=NULL)
	{
		uint16_t i;
		int len=strlen(head);
		for(i=0;h[i+len]!='\r'&&h[i+len]!='\n'&&h[i+len]!=' ';i++)
		{
			get_data[i]=h[i+len];	
		}
		get_data[i]='\0';//Ͻ
	}else
	{
		if(!strstr(buff,head))debug_printf("\r\nδܼ־λ\r\n");	
		debug_printf("\r\nԭ:\r\n");
		debug_printf(buff);
		return 0;
	}
	return 1;
}




/**@brief AT_Extract_numbers :ᴿȥֵĲ
* @param  buff			 : ᴿַʵ飬Ҫд
*/
uint8_t AT_Extract_numbers(char buff[]) {
		
	uint16_t i=0,n=0;
	int len=strlen(buff);
	char fifo[len+1];/*˷ѿռ䣬Чʸ*/
	memset(fifo,0,len+1);
	
	for(;buff[i]!='\0';)
	{
		if(buff[i]>='0'&&buff[i]<='9')
		{			
			fifo[n]=buff[i];
			n++;
			i++;
		}
		else
		{
			i++;
		}
	}
	//debug_printf("\r\n");
	//debug_printf(fifo);
	strcpy(buff,fifo);
	return 1;
}

/**@brief AT_Extract_numbers :ᴿȥֺͷĸĲ
* @param  buff			 : ᴿַʵ飬Ҫд
*/
uint8_t AT_Extract_numbers_letters(char buff[]) {
		
	uint16_t i=0,n=0;
	int len=strlen(buff);
	char fifo[len+1];/*˷ѿռ䣬Чʸ*/
	memset(fifo,0,len+1);
	for(;buff[i]!='\0';)
	{
		if((buff[i]>='0'&&buff[i]<='9')||(buff[i]>='A'&&buff[i]<='Z')||(buff[i]>='a'&&buff[i]<='z'))
		{			
			fifo[n]=buff[i];
			n++;
			i++;
		}
		else
		{
			i++;
		}
	}
	//debug_printf("\r\n");
	//debug_printf(fifo);
	strcpy(buff,fifo);
	return 1;
}

/**@brief AT_Remove_spaces :ȥַ,\r,\n,space
* @param  buff			 : ᴿַʵ飬Ҫд
*/
uint8_t AT_Remove_spaces(char buff[]) 
{
	uint16_t i=0,n=0;
	int len=strlen(buff);
	char fifo[len+1];/*˷ѿռ䣬Чʸ*/
	memset(fifo,0,len+1);
	for(;buff[i]!='\0';)
	{
		if((buff[i]!='\r')&&(buff[i]!='\n')&&(buff[i]!=' '))
		{			
			fifo[n]=buff[i];
			n++;
			i++;
		}
		else
		{
			i++;
		}
	}
	strcpy(buff,fifo);
	return 1;		
}


/*-----------------------------------------滻׼----------------------------------------------------*/



#define hasNulByte(x) ((x - 0x01010101) & ~x & 0x80808080)
/*
ֳ CPU ģⰴֽΪȲǱȽϺʱģ
ǰֱa, bԲִУ
һֱĴ֮УٶȽϿ㣻

жϵһǷ nulڣɨЧλõ nul ַ
ɨʣַд nulɨ貢λá
λλɨ
*/
/*ԲԱc99 cstrlenٶȿһ*/

#define SW (sizeof (int) / sizeof (char))

int my_strlen (const char *s) {
const char *p;
int d;

		p = s - 1;
		do {
				p++;
				if ((((int) p) & (SW - 1)) == 0) {
						do {
								d  = *((int *) p);
								p += SW;
						} while (!hasNulByte (d));
						p -= SW;
				}
		} while (*p != 0);
		return p - s;
}

/*ԱC׼һ*/
char *my_strstr(const char *str, const char *sub_str)
{
    for(int i = 0; str[i] != '\0'; i++)
    {
        int tem = i; //temеʼж±λ 
        int j = 0;
        while(str[i++] == sub_str[j++])
        {
            if(sub_str[j] == '\0')
            {
                return (char*)&str[tem];
            }
        }
        i = tem;
    }

    return NULL;
}

/*ԲԣCԴٶȲ,βһ*/
char*my_strcpy(char*dest, const char*src)
{
	//if(dest == NULL)return 0;   
	if(src == NULL)return 0;
	char*start = dest;
	
	/*destַδʼҲԿʼ*/
	while ((uint8_t)((*dest++) = (*src++)))
		;
	return start;
}

/*ԣ󲿷Կ*/
char*my_strcat(char*dest, const char*src)
{
	if(dest == NULL)	return 0;  
	
	char *start = dest;
	while (*dest)
		dest++;
	while ((uint8_t)(*dest++ = *src++))
		;
	return start;
}


/*---------------------------------滻ⲿֶûC-------------------------------------------------------*/
/*
		21/1/6  ܶຯǳ̵ʱдģڶⲿֺãһЧʣramʹãо
		C
*/

/**@brief ReplaceString		 : ȡ־ַĲ	
* @param  src			 				 : ԴַúֱԴַ޸
* @param  bereplaced       : 滻
* @param  replace     		 : 滻ɵ

 УԴַ󳤶ȣʹУ飬Լٲ

* ַ AT+QMTCFG="aliauth",0,"a1XVq3z4DsR"
*				 str1 "aliauth",str2 "recv/mode",滻buff: AT+QMTCFG="recv/mode",0,"a1XVq3z4DsR"
*   	ҪΪ˱ʹö̬ڴԼСڴƬĿ,渴Ӷ°βûнϴ,ûC
			ֻʮҵĲջռԿ졾Ͼջķ㷨򵥡
*/

uint8_t ReplaceString(char * src,char*bereplaced,char* replace)
{
	/*ȡ*/
	int i,flag = 0;
  char *p,*q;
  for(i = 0; src[i]; ++i)
  {
      if(src[i] == bereplaced[0]) 
      {
         p = src + i;
				
         q = bereplaced;
				
         while(*q && (*p++ == *q++));
				
         if(*q == '\0') 
         {
							char temp[my_strlen(src) + 1]; 
							my_strcpy(temp,p);
							src[i] = '\0';
							my_strcat(src,replace);
							my_strcat(src,temp);
							
							flag = 1;
         }
      }
    }
    return flag;
}

/**@brief ReplaceSpace		 : ޳ıո\r\n	
* @param  src			 				 : ԴַúֱԴַ޸

* 	Ϊ滻  AT_Remove_spaces ռ䣬Чʸ
*/

uint8_t ReplaceSpace(char * src)
{
	int i,j;
	for(i=j=0;src[i]!='\0';i++){
		if(*(src+i)!='\r'&&*(src+i)!='\n'&&*(src+i)!=' '){
			src[j++]=src[i]; 
		}
	}
	src[j]='\0';
			
	return 1;
}

/**@brief GetString_Wrapped: ȡ־ַĲ
* @param  src			 				 : ȡַַ̬
* @param  dest	 	 				 : ȡװص飬飬Ǿַ̬ΪҪд
* @param  start_str     	 : ,һַ
* @param  end_str     		 : ,ΪʱstartλÿʼһֱѰβͣȡ

* ʱ䣺21/1/6 :滻 AT_GET_Data_2Param  AT_GET_Data_Param	ڴ棬Խramʹٶ
* ַ "+QGPSGNMEA: $GPRMC,021229.00,A,3041.560083,N,10405.832869,E,0.0,247.3,040920,1.9,W,A*28"
*			head ",A",tail ",N",װؽget_data: "3041.560083"
* 	ʱԼΪ AT_GET_Data_2Param  54%
*/
uint8_t GetString_Wrapped(char * src,char *dest,char*start_str,char* end_str)
{
	/*ȡ*/
	int len=my_strlen (src);
	char *start_p=0,*end_p=0;
		
	if((int)(start_p=my_strstr(src,start_str)))
	{
		start_p+=my_strlen(start_str);
		
		/*β*/
		if((int)(end_p=my_strstr(start_p,end_str)))
		{
			while (start_p != end_p)
			(*dest++) = (*start_p++);
			
			*dest='\0';
			return 1;
			
		}else /*ûβ*/
		{
			/*Ϊûо*/
			while ((uint8_t)(*dest++ = *start_p++))
			;
			*dest='\0';
			return 3;
		}
	}else return 0;
}


/**@brief GetString: ȡڼڼ־֮Ĳ
* @param  src			 : ȡַַ̬
* @param  dest	 	 : ȡװص飬飬Ǿַ̬ΪҪд
* @param  sign     : ,һַ
* ʱ䣺21/1/6 :滻 AT_GET_Data ڴ棬Խramʹٶ

*   ַ "AT+MIPOPEN=1,"TCP","122.114.122.174",41838,100,0,1,2,11002"
*			 	 start=1  end=2	ȡΪ "TCP"
*     ʱԼΪ AT_GET_Data  54%
*/
char* GetString_StartEnd(char * src,char *dest,char*sign,uint8_t start,uint8_t end)
{
	/*ȡ*/
	int len=my_strlen (src);
	char *start_p=0,*end_p=0;
	int  loc=0;
	
	if(start>=len||end<=start) return 0;
	if((start_p=my_strstr(src,sign))!=0)
	{
		loc++;
		while(loc<start)
		{
			if((start_p=my_strstr(start_p+1,sign))!=0)
			{
				loc++;
			}else return 0;
			if(loc==start) break;
		}
		if(start_p+1==0)return 0;
		
		end_p=start_p;
		/*һѾҵ㣬strpָ*/
		while(loc<end)
		{
			if((end_p=my_strstr(end_p+1,sign))!=0)/*ֹ뾯*/
			{
			loc++;
			}else return 0;
			
			if(loc==end) break;
		}
		start_p++;	
		
		while (start_p != end_p)
			(*dest++) = (*start_p++)
		;
		
		*dest='\0';
		
		return start_p;
		
	}else return 0;
}




