/** ******************************************************************************
 * @file    serialport.c
 * @author  
 * @brief   halĴڿ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾2.0		ʱ 20/12/21  ˳ṹ
 ********************************************************************************/
#include <stdarg.h>				/*C*/
#include <string.h>				/*C*/
#include <stdio.h>				/*C*/
#include <stdlib.h>

#include "serialport.h"   /*ļͷļ*/ 
#include "uart_frameconf.h"
#include "uart_framedriver.h"

#include "at_module.h"
/********************************************************************************/
//#include "usart.h"						/*HALӲ*/

/********************************************************************************/

/* 
ʼ 												  				UartModuleInit();			 ȫֳʼ  

ѭѭ 												LoopReadData();				 ѯȡ

ڼʱ  	  													TimerInterruptTask();  ʱ

*/
/********************************************************************************/
#define MAXHOOKSIZE							20

struct Uart_Frame_Param
{
	/*¼ճ*/
	uint32_t  rxbuff_count;
	/*ճȻ*/
	uint32_t  rxbuff_len;
	/*ջջĴС*/
	uint32_t  rxbuff_size;
	/*жݵļʱ*/
	int 			wait_time;
	/*Ϊʱʵװֵ*/
	int 			reload_time;
	/*װصݵİλ*/
	uint8_t 	uart_8bit;
	/*װؽյĴݵ*/
	uint8_t   *rxbuff;
	/*װɺ飬ݴٶȹл*/
	uint8_t   *rxbuff_cache; 
	/*ڵľ*/	
	void 			*uart_handle;
	/*־*/	
	uint8_t 	end_mark; 
	/*жϼ*/
	uint32_t  IndependentITcount;
  /*ܵĽֽ*/
  uint64_t  RxAllcount;
	
	uint8_t   BlockFlug;
 	
	struct HOOK_frame* hookmessagelist[MAXHOOKSIZE];
	
	uint8_t hookusage;
};

struct Uart_Frame_Task
{
	/*Ͼ*/
	void (*OverTask)(uint8_t *cache,int length);
	
};
 

typedef struct Uart_Frame
{
	struct Uart_Frame_Param Param;
	
	struct Uart_Frame_Task	Instance;
	
//	/*ʽӡָ*/
//	void (*Printf)(const char *format, ...);
//	/*ͺ*/
//	void (*Send)(uint8_t *txbuf,uint32_t len);	
//	/*ȡݣóʱʱ*/
//	uint8_t (*BlockRead)(char rxbuf[],uint32_t overtime_ms);
//	/*עϾ亯*/
//	void (*RegistPuncCallBack)(void (*CallTask)(uint8_t *cache,int length));
//	/*עṳӺ*/
//	uint8_t (*RegistHookCallBack)(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
//	/*˫*/
//	void (*LoadCache)(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
	
}UartCore,*UartCoreHand;



/*--------------------------¼ܹλ---------------------------------------------------------*/
/*ʱĵ TimerInterruptTask */
uint8_t 	TimedTaskCaller(void);
/*ʱִУִ LoopReadData */
uint8_t 	TimedTaskActuator(void);

/*moduleʹõĴλ*/
uint8_t g_modulehand_location=99;

/*̬ĺ*/
void Uart1Printf(const char *format, ...);
void Uart2Printf(const char *format, ...);
void Uart3Printf(const char *format, ...);
void Uart4Printf(const char *format, ...);
void Uart5Printf(const char *format, ...);
void Uart6Printf(const char *format, ...);
void Uart7Printf(const char *format, ...);
void Uart8Printf(const char *format, ...);
void Uart9Printf(const char *format, ...);

void Uart1Send(uint8_t *txbuf,uint32_t len);
void Uart2Send(uint8_t *txbuf,uint32_t len);
void Uart3Send(uint8_t *txbuf,uint32_t len);
void Uart4Send(uint8_t *txbuf,uint32_t len);
void Uart5Send(uint8_t *txbuf,uint32_t len);
void Uart6Send(uint8_t *txbuf,uint32_t len);
void Uart7Send(uint8_t *txbuf,uint32_t len);
void Uart8Send(uint8_t *txbuf,uint32_t len);
void Uart9Send(uint8_t *txbuf,uint32_t len);


uint8_t Uart1_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart2_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart3_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart4_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart5_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart6_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart7_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart8_BlockingRead(char rxbuf[],uint32_t overtime_ms);
uint8_t Uart9_BlockingRead(char rxbuf[],uint32_t overtime_ms);

void RegistPuncCallBack_1(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_2(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_3(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_4(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_5(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_6(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_7(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_8(void(*CallTask)(uint8_t *cache,int length));
void RegistPuncCallBack_9(void(*CallTask)(uint8_t *cache,int length));

void LoadCache_1(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_2(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_3(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_4(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_5(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_6(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_7(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_8(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
void LoadCache_9(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);


uint8_t HookRegister_1(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_2(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_3(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_4(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_5(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_6(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_7(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_8(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
uint8_t HookRegister_9(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);

/*ִ*/
uint8_t HookActuator(uint8_t *message,uint16_t length,struct HOOK_frame *HookMessageList[],int HookLen);


/*ڲָ*/
UartCoreHand  CoreList[9]={0};

/*ⲿָ*/
SerialCoreHand    SerialCoreList[9]={0};

/*洢ʹ*/
uint8_t  CoreListUsage=0;
/*ȫִжϼ*/
uint32_t  g_UartITCount=0;
/*ȫȫprintfͳȣ¶ȥź*/
uint16_t printf_max=512;

void UartCoreBind(SerialCoreHand uartcore,void *huart)
{
	/*洢ָ*/
	if(CoreListUsage<10)
	{
	UartCoreHand ne_uartc=malloc(sizeof(UartCore));
	/*ڲõĹܾ*/
	CoreList[CoreListUsage]=ne_uartc;
	/*洢ĸⲿʹõľ*/	
	SerialCoreList[CoreListUsage]=uartcore;
		
	ne_uartc->Param.reload_time=3;
	ne_uartc->Param.uart_handle=huart;
		
	/*ʼ*/
	ne_uartc->Param.BlockFlug=0;
	ne_uartc->Param.rxbuff=0;
	ne_uartc->Param.rxbuff_cache=0;
	ne_uartc->Param.rxbuff_count=0;
	ne_uartc->Param.reload_time=30;	
		
		/*װشھ*/
 	
	ne_uartc->Param.end_mark=0;     
	/*uartָ븳ֵ*/

	/*ջ*/
		
	/*Ϊ֧ʽΣΪ˿㡾ôΡֻrom*/
	switch(CoreListUsage)
	{
		case 0:
		{
		 uartcore->Send=Uart1Send;
		 uartcore->Printf=Uart1Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_1;
		 uartcore->RegistHookCallBack=HookRegister_1;
		 uartcore->LoadCache=LoadCache_1;
		 break;
		}
		case 1:
		{
			uartcore->Send=Uart2Send;
			uartcore->Printf=Uart2Printf;
			uartcore->RegistPuncCallBack=RegistPuncCallBack_2;
			uartcore->RegistHookCallBack=HookRegister_2;
			uartcore->LoadCache=LoadCache_2;
			break;
		}
		case 2:
		{
		 uartcore->Send=Uart3Send;
		 uartcore->Printf=Uart3Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_3;
		 uartcore->RegistHookCallBack=HookRegister_3;
		 uartcore->LoadCache=LoadCache_3;
		 break;
		}
		case 3:
		{
		 uartcore->Send=Uart4Send;
		 uartcore->Printf=Uart4Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_4;
		 uartcore->RegistHookCallBack=HookRegister_4;
		 uartcore->LoadCache=LoadCache_4;
		 break;
		}
		case 4:
		{
		 uartcore->Send=Uart5Send;
		 uartcore->Printf=Uart5Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_5;
		 uartcore->RegistHookCallBack=HookRegister_5;
		 uartcore->LoadCache=LoadCache_5;
		 break;
		}
		case 5:
		{
		 uartcore->Send=Uart6Send;
		 uartcore->Printf=Uart6Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_6;
		 uartcore->RegistHookCallBack=HookRegister_6;
		 uartcore->LoadCache=LoadCache_6;
		 break;
		}
		case 6:
		{
		 uartcore->Send=Uart7Send;
		 uartcore->Printf=Uart7Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_7;
		 uartcore->RegistHookCallBack=HookRegister_7;
		 uartcore->LoadCache=LoadCache_7;
		 break;
		}	
		case 7:
		{
		 uartcore->Send=Uart8Send;
		 uartcore->Printf=Uart8Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_8;
		 uartcore->RegistHookCallBack=HookRegister_8;
		 uartcore->LoadCache=LoadCache_8;
		 break;
		}
		case 8:
		{
		 uartcore->Send=Uart9Send;
		 uartcore->Printf=Uart9Printf;
		 uartcore->RegistPuncCallBack=RegistPuncCallBack_9;
		 uartcore->RegistHookCallBack=HookRegister_9;
		 uartcore->LoadCache=LoadCache_9;
		 break;
		}
	}
	
	switch(CoreListUsage)
	{
		case 0:uartcore->BlockRead=Uart1_BlockingRead;break;
		case 1:uartcore->BlockRead=Uart2_BlockingRead;break;
		case 2:uartcore->BlockRead=Uart3_BlockingRead;break;
		case 3:uartcore->BlockRead=Uart4_BlockingRead;break;
		case 4:uartcore->BlockRead=Uart5_BlockingRead;break;
		case 5:uartcore->BlockRead=Uart6_BlockingRead;break;
		case 6:uartcore->BlockRead=Uart7_BlockingRead;break;
		case 7:uartcore->BlockRead=Uart8_BlockingRead;break;
		case 8:uartcore->BlockRead=Uart9_BlockingRead;break;
	}
	
	HAL_UART_Receive_IT(ne_uartc->Param.uart_handle,&(ne_uartc->Param.uart_8bit),1);
	
	CoreListUsage++;
	
	}
	else {};
	
}
volatile uint32_t delay_count=0;

void MyDelay(uint32_t time)
{
	delay_count=time;
	while(delay_count);
}

/*ںеʱ*/
void UartCoreTick(void)
{
	/*ʱ*/
	delay_count--;
	/*ڶϾ*/
	for(int i=0;i<CoreListUsage&&i<10;i++)
	{
		if(CoreList[i]->Param.wait_time>-1) CoreList[i]->Param.wait_time--;
		
		if(CoreList[i]->Param.wait_time==0)
		{
			memcpy(CoreList[i]->Param.rxbuff_cache,CoreList[i]->Param.rxbuff,CoreList[i]->Param.rxbuff_size);
			
			CoreList[i]->Param.rxbuff_len=CoreList[i]->Param.rxbuff_count;
																					
			memset(CoreList[i]->Param.rxbuff,0,CoreList[i]->Param.rxbuff_size);//,Ҳǵ		
			
			CoreList[i]->Param.rxbuff_count=0;
			
			CoreList[i]->Param.end_mark=1;
		}	
	}
	
	/*ʱ*/
	#if(configMODULETIMERTASK	)
	TimedTaskCaller();
	#endif
}

/*Ƕױ־Ƕʱִͬ*/
uint8_t NESTING_FLUG;

/*ںѯ*/
uint8_t UartCoreLoop()
{

	for(int i=0;i<CoreListUsage&&i<10;i++)
	{
		
		if(CoreList[i]->Param.BlockFlug==0) 
		{
					
					if(CoreList[i]->Param.end_mark)
					{
						
						CoreList[i]->Param.end_mark=0;
						#if(configMODULEDEBUGPASS)
						DebugPassTask(uart_handle_1,uart_handle_1.rxbuff_cache,uart_handle_1.rxbuff_len);
						#else
						#if(configHOOKGROUPENABLE_1)
						if(HookActuator(CoreList[i]->Param.rxbuff_cache,CoreList[i]->Param.rxbuff_len,(CoreList[i]->Param.hookmessagelist),CoreList[i]->Param.hookusage))
						{
							
						}
						else
						#endif
						{
						if(CoreList[i]->Instance.OverTask!=NULL)  /*ýɻص*/
						CoreList[i]->Instance.OverTask(CoreList[i]->Param.rxbuff_cache,CoreList[i]->Param.rxbuff_len);
						else info("The completion callback function has not been registered");	
						}		
						#endif
						
						
						#if(1)
						memset(CoreList[i]->Param.rxbuff_cache,0,CoreList[i]->Param.rxbuff_size);
						#endif
					}
		}

	}
	
	#if(configMODULETIMERTASK)
	/*ģȡ׶Σֹͣʱĵãⱬջ*/
	if(NESTING_FLUG!=1)TimedTaskActuator();
	#endif
	return 1;
}

/*עϾ*/
void _RegistPuncCallBack(UartCoreHand uartcore,void(*CallTask)(uint8_t *cache,int length))
{
	uartcore->Instance.OverTask=CallTask;
}

/*עỺ*/
void _LoadCache(UartCoreHand uartcore,uint8_t *cache,uint8_t* cacheback,uint16_t cachelen)
{
	uartcore->Param.rxbuff=cache;
	uartcore->Param.rxbuff_cache=cacheback;
	uartcore->Param.rxbuff_size=cachelen;
}

void UartCoreRxIT(void *huart)
{
	/*ȫжϵļϣɴֵжǷж*/
	g_UartITCount++;
	
	for(int i=0;i<CoreListUsage&&i<10;i++)
	{
			if(CoreList[i]->Param.uart_handle==huart)
			{
					/*жϼʱ*/
					CoreList[i]->Param.IndependentITcount++;
					/*ȡһδڼĴ*/
					CoreList[i]->Param.rxbuff[CoreList[i]->Param.rxbuff_count]=CoreList[i]->Param.uart_8bit;
				
					/*һжϽ,һνһλ*/
					HAL_UART_Receive_IT(CoreList[i]->Param.uart_handle,&(CoreList[i]->Param.uart_8bit),1);
					
					if(CoreList[i]->Param.rxbuff_count<CoreList[i]->Param.rxbuff_size-1)
					{
						CoreList[i]->Param.rxbuff_count++;
						
						CoreList[i]->Param.RxAllcount++;
					}
					else  
					{
					//СĴ
					
					}
					/*װжϵʱ*/
					CoreList[i]->Param.wait_time=CoreList[i]->Param.reload_time;	
					return;
			}
	}
}



/*ȡʵ*/
uint8_t UartBlockingRead(UartCoreHand uartcore,char rxbuf[],uint32_t overtime_ms)
{
	NESTING_FLUG=1;
	
	volatile uint32_t overtime_flug=1;
	uartcore->Param.BlockFlug=1;
	while(1)
	{
		if((uartcore->Param.end_mark))
		{
			uartcore->Param.end_mark=0;
			memcpy(rxbuf,uartcore->Param.rxbuff_cache,uartcore->Param.rxbuff_len);
			#if(configMODULEPRINTF_INFO)
			debug_printf("R >>[%s]\r\n",rxbuf);
			#endif
			
			memset(uartcore->Param.rxbuff_cache,0,uartcore->Param.rxbuff_len);
			uartcore->Param.BlockFlug=0;
			NESTING_FLUG=0;
			return overtime_flug;
		}
		MyDelay(1);	
		UartCoreLoop();
		overtime_flug++;
		if(overtime_flug>=overtime_ms) 
		{
			memset(uartcore->Param.rxbuff_cache,0,uartcore->Param.rxbuff_len);
			debug_printf("block read over time ;");	
			uartcore->Param.BlockFlug=0;
			NESTING_FLUG=0;
			return 0;
		}
	}	
}

void SetPrintStack(uint32_t size)
{
	printf_max=size;
}

/*--------------------------------------------------------------------------------------------------------------------------*/






/*ע飬û취Cû취ʽκͻȡãֲ̫*/
void RegistPuncCallBack_1(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[0],CallTask);
}
void RegistPuncCallBack_2(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[1],CallTask);
}
void RegistPuncCallBack_3(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[2],CallTask);
}
void RegistPuncCallBack_4(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[3],CallTask);
}
void RegistPuncCallBack_5(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[4],CallTask);
}
void RegistPuncCallBack_6(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[5],CallTask);
}
void RegistPuncCallBack_7(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[6],CallTask);
}
void RegistPuncCallBack_8(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[7],CallTask);
}
void RegistPuncCallBack_9(void(*CallTask)(uint8_t *cache,int length))
{
	_RegistPuncCallBack(CoreList[8],CallTask);
}
/*뻺ʵ飬û취Cû취ʽκͻȡãֲ̫*/
void LoadCache_1(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[0],cache,cacheback,cachelen);
}
void LoadCache_2(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[1],cache,cacheback,cachelen);
}
void LoadCache_3(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[2],cache,cacheback,cachelen);
}
void LoadCache_4(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[5],cache,cacheback,cachelen);
}
void LoadCache_5(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[4],cache,cacheback,cachelen);
}
void LoadCache_6(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[5],cache,cacheback,cachelen);
}
void LoadCache_7(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[6],cache,cacheback,cachelen);
}
void LoadCache_8(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[7],cache,cacheback,cachelen);
}
void LoadCache_9(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen)
{
	_LoadCache(CoreList[8],cache,cacheback,cachelen);
}

enum SerialInfo
{
	 IT_Total=1,		/*ܵжϴ*/
	 IT_Serial=2,		/*󶨴ڵжϴ*/
	 Byte_Stream=3, /*󶨴µ*/
	 Func_Total=4,	/*󶨴¶Ͼ*/
	 
};

uint64_t  _ReadData(enum SerialInfo data )
{
	
	return 1;
}


/*ջ*/


/**
	HALṹĴڻص,˫ģʽ£ж϶ڴʵ
*/




#if (UART_GROUP_1)
#if configPRINTFREDEFINITION  /*ʹض*/

/*ضprintf,ַֹԽ*/
void Uart1Printf(const char *format, ...)
{	
    va_list args;
    uint32_t length;
		/*ͳȹʱС*/
    uint8_t txbuf[printf_max];
		
		//
    va_start(args, format);
    length = vsnprintf((char *)txbuf,printf_max, (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[0]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
#endif

/**/
void Uart1Send(uint8_t *txbuf,uint32_t len)
{
		HAL_UART_Transmit(CoreList[0]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}
#endif

#if UART_GROUP_2
#if configPRINTFREDEFINITION  /*ʹض*/
void Uart2Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max];
	
    va_start(args, format);
    length = vsnprintf((char *)txbuf,printf_max, (char *)format, args);
		
    va_end(args);
    HAL_UART_Transmit(CoreList[1]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
#endif
/**/
void Uart2Send(uint8_t *txbuf,uint32_t len)
{
		HAL_UART_Transmit(CoreList[1]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

#endif


#if UART_GROUP_3
#if configPRINTFREDEFINITION 	/*ʹض*/
void Uart3Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max];
	
    va_start(args, format);
    length = vsnprintf((char *)txbuf, printf_max, (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[2]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
#endif

void Uart4Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max];
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[3]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
void Uart5Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max] ;
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[4]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
void Uart6Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max] ;
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[5]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}
void Uart7Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max];
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[6]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}

void Uart8Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max] ;
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[7]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}

void Uart9Printf(const char *format, ...)
{
    va_list args;
    uint32_t length;
    uint8_t txbuf[printf_max];
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(CoreList[8]->Param.uart_handle, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0, printf_max);
}

/**/
void Uart3Send(uint8_t *txbuf,uint32_t len)
{		
	HAL_UART_Transmit(CoreList[2]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart4Send(uint8_t *txbuf,uint32_t len)
{		
	HAL_UART_Transmit(CoreList[3]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart5Send(uint8_t *txbuf,uint32_t len)
{  
 HAL_UART_Transmit(CoreList[4]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart6Send(uint8_t *txbuf,uint32_t len)
{  
 HAL_UART_Transmit(CoreList[5]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart7Send(uint8_t *txbuf,uint32_t len)
{  
 HAL_UART_Transmit(CoreList[6]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart8Send(uint8_t *txbuf,uint32_t len)
{  
 HAL_UART_Transmit(CoreList[7]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}

void Uart9Send(uint8_t *txbuf,uint32_t len)
{  
 HAL_UART_Transmit(CoreList[8]->Param.uart_handle,txbuf,len,0xFFFFFFFFU);
}
#endif




#if (UART_GROUP_1)
/*ʽĶȡһӦ*/
uint8_t Uart1_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[0],rxbuf,overtime_ms);
}
uint8_t Uart2_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[1],rxbuf,overtime_ms);
}
uint8_t Uart3_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[2],rxbuf,overtime_ms);
}
uint8_t Uart4_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[3],rxbuf,overtime_ms);
}
uint8_t Uart5_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[4],rxbuf,overtime_ms);
}
uint8_t Uart6_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[5],rxbuf,overtime_ms);
}
uint8_t Uart7_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[6],rxbuf,overtime_ms);
}
uint8_t Uart8_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
return UartBlockingRead(CoreList[7],rxbuf,overtime_ms);
}
uint8_t Uart9_BlockingRead(char rxbuf[],uint32_t overtime_ms)
{
	return UartBlockingRead(CoreList[8],rxbuf,overtime_ms);
}


#endif

#if (UART_GROUP_2)
/*ʽĶȡһӦ*/

#endif

#if (UART_GROUP_3)
/*ʽĶȡһӦ*/

#endif



/*--------------չ---------------*/
#ifdef DEBUG_UART

void *g_debugSerial;

void SetDebugSerial(void *debugSerial)
{
	g_debugSerial=debugSerial;
}

void debug_printf(const char *format, ...)
{
		va_list args;
    uint32_t length;
		/*ͳȹʱС*/
    uint8_t txbuf[512] = {0};
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(g_debugSerial, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
    memset(txbuf, 0,512);
}

#endif

#ifdef MODULE_UART

void *g_ModuleSerial;

void SetModuleSerial(void *moduleSerial)
{
	g_ModuleSerial=moduleSerial;
}

void module_printf(const char *format, ...)
{
		va_list args;
    uint32_t length;
		/*ͳȹʱС*/
    uint8_t txbuf[512] = {0};
 
    va_start(args, format);
    length = vsnprintf((char *)txbuf, sizeof(txbuf), (char *)format, args);
    va_end(args);
    HAL_UART_Transmit(g_ModuleSerial, (uint8_t *)txbuf, length, 0xFFFFFFFFU);
		//debug_printf(txbuf);
    memset(txbuf, 0,512);
}

//uint8_t g_modulehand_location=99;

SerialCoreHand g_module_hand_support=0;
//void *  g_module_hand_support=0;
/*һںómodulemoduleصĺᵼں*/
uint8_t SetCoreIsModule(SerialCoreHand hand)
{
	for(int i=0;i<10;i++)
	{
	if(SerialCoreList[i]!=0)
	{
		if(SerialCoreList[i]==hand)
		{
		g_modulehand_location=i;
		
		g_module_hand_support=hand;
		//g_module_hand_support=CoreList[g_modulehand_location];
		
		return 1;	
		}
		

	}
	
	}
	return 0;
}

/*˭ģ*/


uint8_t Module_Blocking_Read(char rxbuf[],uint32_t overtime_ms)
{
	volatile uint32_t overtime_flug=0;
	
	CoreList[g_modulehand_location]->Param.BlockFlug=1;
	NESTING_FLUG=1;
	while(1)
	{
		if((CoreList[g_modulehand_location]->Param.end_mark))
		{
			CoreList[g_modulehand_location]->Param.end_mark=0;
			
			memcpy(rxbuf,CoreList[g_modulehand_location]->Param.rxbuff_cache,CoreList[g_modulehand_location]->Param.rxbuff_len);
			#if(configMODULEPRINTF_INFO)
			debug_printf("R >>[%s]\r\n",rxbuf);
			#endif
			
			
			memset(CoreList[g_modulehand_location]->Param.rxbuff_cache,0,CoreList[g_modulehand_location]->Param.rxbuff_len);
			CoreList[g_modulehand_location]->Param.BlockFlug=0;
			NESTING_FLUG=0;
			return 1;
		}
		UartCoreLoop();
		MyDelay(1);	
		overtime_flug++;
		if(overtime_flug>=overtime_ms) 
		{
			memset(CoreList[g_modulehand_location]->Param.rxbuff_cache,0,CoreList[g_modulehand_location]->Param.rxbuff_len);
			info("ʱ");	
			CoreList[g_modulehand_location]->Param.BlockFlug=0;
			NESTING_FLUG=0;
			return 0;
		}
	}	
}

#endif

/*---------------------------------------------------------------------------------------*/





/*ջϵַָָѣ顣*/

/**@brief ڻ
* :		ClearCache("UART_GROUP_1")
*/




/**************************************20/12/30***************************************************************/

/** ƻʵһϵͳͨעṳȡݣ
*   ʹö̬ڴ棬ʹù̶洢
*		Ŀǹȡͨݣʹӡɻصз
*/

/**@brief Hookִ
	20/1/4 ֱӲȫֱΪԹúܻ΢½ǶĶȥ˲ں㡣
*/
/*һȫֵĹʵ*/
struct HOOK_frame
{
	/*ҪץȡϢ*/
	uint8_t *message;
	/*ظ*/
	uint8_t  message_len;
	/*ֵȫץǾͷץ,Ƿʹ*/
	uint8_t  hook_mode;
	/*עĹӺ*/
	uint8_t (*Task)(uint8_t *message,uint16_t length);
	
};


#if (HookMode_HEAD)
uint8_t g_GrabHead[]=GRABHEAD;
#endif

uint8_t HookActuator(uint8_t *message,uint16_t length,struct HOOK_frame *HookMessageList[],int HookLen)
{
		/*עĹ*/
		for(int i=0;i<HookLen;i++)
		{
			//debug_printf("message[%s]\r\n",HookMessageList[i]->message);
			/*עϢǿգִ*/
			if(HookMessageList[i]->message!=NULL)
			{
					/*ͷץģʽУ飬*/
					if(HookMessageList[i]->hook_mode)
					{
						/*жϵһַǷ*/
						for(int i=0;i<HookMessageList[i]->message_len&&i<MAXHOOKSIZE;i++)
						{
							if(*(HookMessageList[i]->message)!=*(message+i))return 0;
						}

						/*ǷҪץȡϢͷ*/
						if(strstr((char*)message,(char*)HookMessageList[i]->message))
						{
							if(HookMessageList[i]->Task!=NULL)
							{
								//debug_printf("ͷץ[%s][%s]\r\n",message,HookMessageList[i].message);
								/*ùӺ*/
								HookMessageList[i]->Task(message,length);
							}
							return 1; /*Ƿע˹ӻص1*/
						}
						else{
							//return 0;
						}
					}
					else /*ȫļ*/
					{

								/*ǷҪץȡϢ*/
								if(strstr((char*)message,(char*)HookMessageList[i]->message))
								{
									if(HookMessageList[i]->Task!=NULL)
									{
										//debug_printf("ȫץ[%s][%s]\r\n",message,HookMessageList[i].message);
										/*ùӺ*/
										HookMessageList[i]->Task(message,length);
									}
									return 1; /*Ƿע˹ӻص1*/
								}
								else
								{
									//return 0;
								}
					}
			
			}
		}
		return 0;
}

/**@brief Hook ע
	* ҪȡĲע
*/
uint8_t _HookRegister(UartCoreHand uartcore,uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t group)
{
	/*ö̬ڴ棬ǲö̬ڴĻھֲʹ˷ȫֵעϢϢͻʧ*/
	/*̬*/
	if((uartcore->Param.hookusage)<MAXHOOKSIZE)
	{
	struct HOOK_frame *hook=(struct HOOK_frame*)malloc(sizeof(struct HOOK_frame));
	/*Ĺӽṹȥ*/
	uartcore->Param.hookmessagelist[uartcore->Param.hookusage]=hook;
	/*̬*/
	uartcore->Param.hookmessagelist[uartcore->Param.hookusage]->message=(uint8_t*)malloc(my_strlen((char*)key));
	/**/
	my_strcpy((char*)(uartcore->Param.hookmessagelist[uartcore->Param.hookusage]->message),(char*)key);
	/*װعӺָ*/
	uartcore->Param.hookmessagelist[uartcore->Param.hookusage]->Task=Task;
	
	uartcore->Param.hookusage++;		
		
	return 1;
	}
	return 0;

	//debug_printf((char*)(uartcore->Param.hookmessagelist[uartcore->Param.hookusage]->message));
	//debug_printf("use:%d",uartcore->Param.hookusage);
}

uint8_t HookRegister_1(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[0],key,Task,hookmode);
}
uint8_t HookRegister_2(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[1],key,Task,hookmode);
}
uint8_t HookRegister_3(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[2],key,Task,hookmode);
}
uint8_t HookRegister_4(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[3],key,Task,hookmode);
}
uint8_t HookRegister_5(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[4],key,Task,hookmode);
}
uint8_t HookRegister_6(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[5],key,Task,hookmode);
}
uint8_t HookRegister_7(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[6],key,Task,hookmode);
}
uint8_t HookRegister_8(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[7],key,Task,hookmode);
}
uint8_t HookRegister_9(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode)
{
	return _HookRegister(CoreList[8],key,Task,hookmode);
}



/** @brief Hook ȥע
	* ҪȡĲ
*/
uint8_t HookRemoveRegistration(uint8_t *key,uint8_t group)
{
	
		int hooklength=0;
	
		struct HOOK_frame *HookMessageList=0;
		
		/*ͨл*/
//		if(GetGroupInfo(group,&HookMessageList,&hooklength))
//		{
					for(int i=0;i<hooklength;i++)
					{
						/*ʱַʽdemo׶*/
						if(strcmp((char*)HookMessageList[i].message,(char*)key))
						{
							/*עṴȡϢ*/
							HookMessageList[i].message=0;
							/*עṳӺ*/
							HookMessageList[i].Task=0;
							/*¼ջС*/
							return 1;
						}
					}
//		}
		return 1;

}



/*ӡϢ*/
uint8_t PrintStackInformation(uint8_t group)
{
		int hooklength=0;
	
		struct HOOK_frame *HookMessageList=0;
		
		/*ͨл*/
		
					info("ע :(%d)\r\n",group);
					for(int i=0;i<hooklength;i++)
					{
						/*ʱַʽdemo׶*/
						if((HookMessageList[i]).message!=NULL)
						{
							/*ӡȡϢ*/
							info("λ:%d,ͷ:%s\r\n",i,(char*)(HookMessageList[i]).message);
						}
					}
		return 0;
}




/*----------------------------------------------------------------------------------------------------------*/
/*21/1/6  ƻһעᶨʱĹܣȻûǷʵʱһᱻģִеص̶ѭǶס
ҪΪ¿㣬Զ񣡡ͳһʱͼʱ߿ЧʺֲЧ*/
#if(configMODULETIMERTASK	)

#define  TIMETASKMAX							15

struct TIMEMODULE
{
	/*װֵ*/
	uint32_t  		 reload; 
	/*ʱʵ*/
	volatile uint32_t  timer; 
	/*ʱѵ*/
	uint8_t       (*TimeTask)(void); 	
	/*ʹܱ־*/
	uint8_t 			 enable;
	/*ֹͣʱ*/
	uint8_t        stop_timer;
	
	int       		 forever;
	/*ҪִеĴ*/
	uint32_t       actuatorcount;
	/*ִм*/
	uint32_t       actuatornumber;

};

/*עȫ*/
struct TIMEMODULE g_timetask[TIMETASKMAX];

uint8_t g_timetaskusage=0;
/*ʱĵ */
uint8_t 	TimedTaskCaller()
{
	for(int i=0;i<g_timetaskusage&&i<TIMETASKMAX;i++)
	{
		if(g_timetask[i].stop_timer) 
		{
			continue;
		}
		else
		{
			if(g_timetask[i].timer>0) g_timetask[i].timer--;
			if(!g_timetask[i].timer)
			{
				g_timetask[i].stop_timer=1;
				g_timetask[i].enable=1;
			}
		}
	}
	return 1;
}

/*ʱִУִ LoopReadData */

uint8_t 	TimedTaskActuator()
{
	for(int i=0;i<g_timetaskusage&&i<TIMETASKMAX;i++)
	{
		if(g_timetask[i].forever>=0)
		{
					if(g_timetask[i].enable==1)
					{
						g_timetask[i].TimeTask();
						g_timetask[i].timer=g_timetask[i].reload;	
						g_timetask[i].stop_timer=0;
						g_timetask[i].enable=0;
						
						if(g_timetask[i].forever!=1)
						{
						g_timetask[i].actuatorcount--;
						if(g_timetask[i].actuatorcount==0) g_timetask[i].stop_timer=1;			
						}
					}
		}

	}
	return  0;
}

/*ʱעִ LoopReadData */
uint8_t TimedTaskRegister(uint32_t timing,uint8_t (*timeTask)())
{
	if(g_timetaskusage<TIMETASKMAX)
	{
		g_timetask[g_timetaskusage].TimeTask=timeTask;
		//g_timetask[g_timetaskusage].enable=1; /*Ĭϲʼ*/
		g_timetask[g_timetaskusage].reload=timing;
		g_timetask[g_timetaskusage].timer=timing;
		g_timetask[g_timetaskusage].enable=0;
		g_timetask[g_timetaskusage].forever=-1;
		g_timetaskusage++;
		return 1;
	}
	return 0;
}



uint8_t TimeTaskStart(uint8_t (*timeTask)(),uint32_t countnumber)
{
	for(int i=0;i<g_timetaskusage&&i<TIMETASKMAX;i++)
	{
		if(g_timetask[i].TimeTask==timeTask)
		{
			if(countnumber)
			{
			g_timetask[i].actuatorcount=countnumber;
			g_timetask[i].timer=g_timetask[i].reload;	
			g_timetask[i].stop_timer=0;	
			g_timetask[i].forever=0;
			}
			else
			{
			g_timetask[i].timer=g_timetask[i].reload;	
			g_timetask[i].stop_timer=0;	
			g_timetask[i].forever=1;				
			}
			return 1;
		}
	}
	return 1;
}

#endif

/*-------------------------------------21/1/25 ---------------------------------------------------------*/

/*ȡڽжǷʹ*/
uint8_t ReadRxITEnable(UART_HandleTypeDef *huart)
{
	//CR1 PEIE  (У)Ужʹ,ԲУλ
	//CR1 RXNEIE RXжʹܣȡUSART_DRԶλ໺ģʽƼ壬TXNEֻܻ
	//CR3 EIE    жʹ,ԲУλ
	#if(0)
	if((huart->Instance->CR3&USART_CR3_EIE)&
		(huart->Instance->CR1&USART_CR1_PEIE)&
	  (huart->Instance->CR1&USART_CR1_RXNEIE)
	  ) 
		return  1;
	else 
		return 0;
	#else
	if((huart->Instance->CR1&USART_CR1_RXNEIE)) 
		return  1;
	else 
		return 0;	
	#endif
}
/*ȡǰõĲ*/
uint16_t ReadSerialBaud(UART_HandleTypeDef *huart)
{
	return huart->Init.BaudRate;
}


