/** ******************************************************************************
 * @file    gm190_library.c
 * @author  
 * @brief   gm190ģATָ״
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * 
 * ļ汾2.0		ʱ2020/12/23   Ϣreadme.txt
 *
 ********************************************************************************/
/*ر*/
#include "gm190_library.h"				 	/*ļͷļ*/
#include "serialport.h"
#include "at_module.h"		 	/*ATָصͷļ*/
#include "string_fuc.h"

#include <stdarg.h>		
#include <string.h>		
#include <stdlib.h>		
#include <stdio.h>	

/********************************************************************************/

struct Uart_Frame_Param
{
	/*¼ճ*/
	uint32_t  rxbuff_count;
	/*ճȻ*/
	uint32_t  rxbuff_len;
	/*ջջĴС*/
	uint32_t  rxbuff_size;
	/*жݵļʱ*/
	int 			wait_time;
	/*Ϊʱʵװֵ*/
	int 			reload_time;
	/*װصݵİλ*/
	uint8_t 	uart_8bit;
	/*װؽյĴݵ*/
	uint8_t   *rxbuff;
	/*װɺ飬ݴٶȹл*/
	uint8_t   *rxbuff_cache; 
	/*ڵľ*/	
	void 			*uart_handle;
	/*־*/	
	uint8_t 	end_mark; 
	/*жϼ*/
	uint32_t  IndependentITcount;
  /*ܵĽֽ*/
  uint64_t  RxAllcount;
 	
	struct HOOK_frame* hookmessagelist[20];
	
	uint8_t hookusage;
};

struct Uart_Frame_Task
{
	/*Ͼ*/
	void (*OverTask)(uint8_t *cache,int length);
	
};
 

typedef struct Uart_Frame
{
	struct Uart_Frame_Param Param;
	
	struct Uart_Frame_Task	Instance;
	
//	/*ʽӡָ*/
//	void (*Printf)(const char *format, ...);
//	/*ͺ*/
//	void (*Send)(uint8_t *txbuf,uint32_t len);	
//	/*ȡݣóʱʱ*/
//	uint8_t (*BlockRead)(char rxbuf[],uint32_t overtime_ms);
//	/*עϾ亯*/
//	void (*RegistPuncCallBack)(void (*CallTask)(uint8_t *cache,int length));
//	/*עṳӺ*/
//	uint8_t (*RegistHookCallBack)(uint8_t *key,uint8_t (*Task)(uint8_t *message,uint16_t length),uint8_t hookmode);
//	/*˫*/
//	void (*LoadCache)(uint8_t *cache,uint8_t *cacheback,uint16_t cachelen);
	
}UartCore,*UartCoreHand;

/*flug =1 flug =0,ѯʿԤ*/
uint8_t OPEN_MODULE(uint8_t flug)
{
	uint8_t rxtemp[512]={0};
	
	uint8_t module_flug=0;
	
	/*TCP汾ɫ*/
	ZIPCREATE_REMOVE();
	/*ѯAT*/
	for(int i=0;i<3;i++)
	{
			module_printf("AT\r\n");
			if(ModuleBlockingRead((char*)rxtemp,200))
			{
				if(my_strstr((char*)rxtemp,"OK")) //
				{
					/*Ѿ*/
					module_flug=1;
					/*ѿ*/
					return 1;
				}
			}	else
			{
				/*ûп*/
				module_flug=0;
			}
	}
	
	/*ʼ*/
	if(module_flug==0)
	{
		info("\r\nִпʱ\r\n");
		
		HAL_Delay(200);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_3, GPIO_PIN_SET);
		HAL_Delay(200);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_3, GPIO_PIN_RESET);
		
		info("\r\nִ\r\n");
		
		memset(rxtemp,0,512);
		/*ȴϢ*/
		if(ModuleBlockingRead((char*)rxtemp,10000))
		{
				/*񿪻Ϣɹ*/
				if(my_strstr((char*)rxtemp,"+ZREADY")) 
				{
					/*Ѿ*/
					module_flug=1;
					/*ѿ*/
					return 1;
				}
		}
		
	}
	
	return 0;		
}

uint8_t CLOSE_MODULE()
{
	uint8_t rxtemp[50]={0};
	
	uint8_t module_flug=0;
	/*ѯAT*/
	for(int i=0;i<3;i++)
	{
			module_printf("AT\r\n");
			if(ModuleBlockingRead((char*)rxtemp,200))
			{
				if(my_strstr((char*)rxtemp,"OK")) //
				{
					/*Ѿ*/
					module_flug=1;
				}
			}	else
			{
				/*ûп*/
				module_flug=0;
				return 1;
			}
	}
	/*ʼػ*/
	module_printf("AT+ZTURNOFF\r\n");
	if(ModuleBlockingRead((char*)rxtemp,1000))
	{

				if(my_strstr((char*)rxtemp,"OK")) //
				{
					/*ػ*/
					return 1;
				}
	}
	return 1;
}



uint8_t QUEERYZIPCALL()
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZIPCALL?\r\n");
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"+ZIPCALL: 1,")) //CALL
		{
			return 1;
		}
		else if(my_strstr((char*)rxtemp,"+ZIPCALL: 0")){//CALL
			return 0;
		}
	}
	return 0;	
	
}

uint8_t ZIPCALL()
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZIPCALL=1\r\n");
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"+ZIPCALL: 1,"))
		{
			return 1;
		}
		else{
			/*ѯһ*/
			if(QUEERYZIPCALL()) 
			{
				return 1;
			}
			else
			{
				return 0; //call
			}
		}
	}
	return 0;
}



uint8_t CEREG()
{
	
	uint8_t rxtemp[512]={0};
	module_printf("AT+CEREG?\r\n");
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"+CEREG: 0,1"))
		{
			return 1;
		}
		else if(my_strstr((char*)rxtemp,"+CEREG: 0,0")){
			return 0;
		}
	}
	return 0;
}

uint8_t CPIN()
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+CPIN?\r\n");
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"+CPIN: READY"))
		{
			return 1;
		}
		else if(my_strstr((char*)rxtemp,"+CME ERROR: 10")){ //+CME ERROR:
			
			int delay=0;
			while(1)
			{
			delay++;
			UartCoreLoop();
			HAL_Delay(1);
			if(delay>=1000)
			{
				debug_printf("δ⵽SIM,SIMϵ\n");	
				delay=0;
			}
			
			}
			
			
			return 0;
		}else
		{
			return 0;
		}
	}
	return 0;
}

/*ģפжϣmode=1 פmode=0 ѯ׶*/
uint8_t ModuleWaitNet(uint8_t mode)
{
	uint8_t flug=0;
	while(1)
	{
		  /*ѯpin*/
			if(CPIN())
			{		
					flug=1;
					/*ѯפ*/
					if(CEREG())
					{
						flug=2;
						/*call*/
						if(ZIPCALL())
						{
							flug=3;
							
							if(mode==0) 
							 return flug;
							
						/*call*/	
							return 1;
						}
						else
						{
						/*ֱcall*/
							
						/*ѯģʽ·״̬*/
						 if(mode==0) 
							 return flug;
						
						}
						
					}else { if(mode==0) return flug;}
			}	else
			{
				if(mode==0) return flug;
			}	
			/*ѯ̫Ӱģ鹤ٶȣ崻פ̸*/
			HAL_Delay(300);
	}
}

/*---------------------------------------------------------------------------------------------------------*/
/*ð汾Ϊmqtt汾*/

char *ZMQHOST=0;

char *ZMQPOR=0;

char *ZMQCID=0;

char *ZMQUSER=0;

char *ZMQPWD=0;


uint8_t MQGETINFO(uint8_t id,char *pid,char*pse,char * did,char *dse)
{
	uint8_t rxtemp[512]={0};
	uint8_t temp2[300]={0};
	info("[AT+ZMQGETINFO=%d,0,%s,%s,%s,%s]\r\n",id,did,dse,pid,pse);
	module_printf("AT+ZMQGETINFO=%d,0,%s,%s,%s,%s\r\n",id,did,dse,pid,pse);
	
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("[%s]",rxtemp);
			
			GetString_Wrapped((char*)rxtemp,(char*)temp2,"+ZMQHOST: ","+");
			ReplaceSpace((char*)temp2);
			if(ZMQHOST==0)
			ZMQHOST=malloc(my_strlen((char*)temp2));
			my_strcpy(ZMQHOST,(char*)temp2);
			
			info("\r\nHOST:[%s]\r\n",ZMQHOST);
			GetString_Wrapped((char*)rxtemp,(char*)temp2,"+ZMQPOR: ","+");
			ReplaceSpace((char*)temp2);
			if(ZMQPOR==0)
			ZMQPOR=malloc(my_strlen((char*)temp2));
			my_strcpy(ZMQPOR,(char*)temp2);
			
			info("\r\nZMQPOR:[%s]\r\n",temp2);
			GetString_Wrapped((char*)rxtemp,(char*)temp2,"+ZMQUSER: ","+");
			ReplaceSpace((char*)temp2);
			if(ZMQUSER==0)
			ZMQUSER=malloc(my_strlen((char*)temp2));
			my_strcpy(ZMQUSER,(char*)temp2);
			
			info("\r\nZMQUSER:[%s]\r\n",temp2);
			
			GetString_Wrapped((char*)rxtemp,(char*)temp2,"+ZMQPWD: ","+");
			ReplaceSpace((char*)temp2);
			if(ZMQPWD==0)
			ZMQPWD=malloc(my_strlen((char*)temp2));
			my_strcpy(ZMQPWD,(char*)temp2);
			info("\r\nZMQPWD:[%s]\r\n",temp2);
			
			
			GetString_Wrapped((char*)rxtemp,(char*)temp2,"+ZMQCID: "," ");
			ReplaceSpace((char*)temp2);
			if(ZMQCID==0)
			ZMQCID=malloc(my_strlen((char*)temp2));
			my_strcpy(ZMQCID,(char*)temp2);
			info("\r\nZMQCID:[%s]\r\n",temp2);
			
			
			return 1;
		}
		info("error:[%s]\r\n",rxtemp);
		return 0;
	}
	info("error:[%s]\r\n",rxtemp);
	return 0;
}



uint8_t ZMQNEW(uint8_t id,char *host,char *por)
{
	uint8_t rxtemp[512]={0};
	
	info("AT+ZMQNEW=%d,%s,%s,500,10000,1\r\n",id,host,por);
	module_printf("AT+ZMQNEW=%d,%s,%s,500,10000,1\r\n",id,host,por);
	
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("\r\nnew ok\r\n");
			return 1;
		}
		return 0;
	}
	return 0;
}

uint8_t ZMQCON(uint8_t id,char * cid,char *user,char*pwd)
{
	uint8_t rxtemp[512]={0};
	info("AT+ZMQCON=%d,4,\"%s\",1000,1,0,%s,%s\r\n",id,cid,user,pwd);
	module_printf("AT+ZMQCON=%d,4,\"%s\",1000,1,0,%s,%s\r\n",id,cid,user,pwd);
	
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("\r\nnew ok\r\n");
			return 1;
		}
		info("%s",(char*)rxtemp);
		return 0;
	}
	info("%s",(char*)rxtemp);
	return 0;	
}

/*ѯMQTT״̬*/
uint8_t ZMQSTART(uint8_t id)
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZMQSTAT=%d\r\n",id);
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		/*ɨ赽0ǵ +ZMQSTAT: 1,0 */
		if(my_strstr((char*)rxtemp,"0"))
		{
			return 0;
		}
		else { //+ZMQSTAT: 1,1
			return 1;
		}
	}
	return 0;
	
}

uint8_t ZMQDISCON(uint8_t id)
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZMQDISCON=%d\r\n",id);
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("\r\ndiscon ok\r\n");
			return 1;
		}
		return 0;
	}
	return 0;
}


uint8_t CONNECT_ALYMQTT(char *pid,char *pse,char*did,char *dse)
{
	if(pid==0||pse==0||did==0||dse==0) return 0;
	for(int i=0;i<2;i++)
	{
		 	if(MQGETINFO(1,pid,pse,did,dse))
			{
				if(ZMQNEW(1,ZMQHOST,ZMQPOR))
				{
					if(ZMQCON(1,ZMQCID,ZMQUSER,ZMQPWD))	
					{
						info("ϰMQTT");
						return 1;
					}
					else
					{

					}
				}
			}
			
			if(ZMQDISCON(1))
			{
						/**/
						info("³");
						continue;
			}	
	}
	return 0;
}



uint8_t ZMQSTAT(uint8_t id)
{
	/*ȷ*/
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZMQDISCON=%d\r\n",id);
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
		}
		return 0;
	}
	return 0;
}

uint8_t ZMQSUB(uint8_t id,char *topic)
{
	uint8_t rxtemp[512]={0};
	module_printf("AT+ZMQSUB=%d,%s,1\r\n",id,topic);

	if(ModuleBlockingRead((char*)rxtemp,5000))
	{	
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("sub OK");
		}
		return 0;	
	}
	return 0;
}


uint8_t ZMQPUB(uint8_t id,char *topic,char *yuanwen)
{
	info("AT+ZMQPUB=%d,%s,1,0,0,%d,%s\r\n",id,topic,my_strlen(yuanwen)/2,yuanwen);
	module_printf("AT+ZMQPUB=%d,%s,1,0,0,%d,%s\r\n",id,topic,my_strlen(yuanwen)/2,yuanwen);

	return 0;
}

struct MQTTTASK{
	
	uint8_t id;
	
	uint8_t (*mqtttask)(uint8_t *message,uint16_t length);
	
};
struct MQTTTASK _mqtask[5]={0};
uint8_t mqtaskuserg=0;

uint8_t SerchDataLoc(char *message)
{
	int i=0,n=0;
	for(;i<7;n++)
	{
		if(*(message+n)==',')i++;
		
		if(i==6)break;
	}
	n++;
	return n;	
	
}

uint8_t MQTT_Handler_1(uint8_t *message,uint16_t length)
{

	my_strcpy((char*)message,(char*)(message+SerchDataLoc((char*)message)));
	
	_mqtask[0].mqtttask(message,strlen((char*)message));
	
	return 1;
	
}
uint8_t  MQTT_Handler_2(uint8_t *message,uint16_t length)
{
	my_strcpy((char*)message,(char*)(message+SerchDataLoc((char*)message)));
	
	_mqtask[1].mqtttask(message,strlen((char*)message));
	
	return 1;
}
uint8_t  MQTT_Handler_3(uint8_t *message,uint16_t length)
{
	my_strcpy((char*)message,(char*)(message+SerchDataLoc((char*)message)));
	
	_mqtask[2].mqtttask(message,strlen((char*)message));
	
	return 1;
}
uint8_t MQTT_Handler_4(uint8_t *message,uint16_t length)
{
	my_strcpy((char*)message,(char*)(message+SerchDataLoc((char*)message)));
	
	_mqtask[3].mqtttask(message,strlen((char*)message));
	
	return 1;
}
uint8_t  MQTT_Handler_5(uint8_t *message,uint16_t length)
{
	my_strcpy((char*)message,(char*)(message+SerchDataLoc((char*)message)));
	
	_mqtask[4].mqtttask(message,strlen((char*)message));
	
	return 1;
}
/*עһصԶ*/
uint8_t NEW_MQTTReceiveHandler(uint8_t (*Task)(uint8_t *message,uint16_t length))
{
	//̶id 1
	mqtaskuserg=0;
	
	if(mqtaskuserg<5)
	{
	switch(mqtaskuserg)
	{
		case 0: g_module_hand_support->RegistHookCallBack((uint8_t*)"+ZMQRCV: 1,",MQTT_Handler_1,0);break;
		case 1:	g_module_hand_support->RegistHookCallBack((uint8_t*)"+ZMQRCV: 2,",MQTT_Handler_2,0);break;
		case 2:	g_module_hand_support->RegistHookCallBack((uint8_t*)"+ZMQRCV: 3,",MQTT_Handler_3,0);break;
		case 3:	g_module_hand_support->RegistHookCallBack((uint8_t*)"+ZMQRCV: 4,",MQTT_Handler_4,0);break;
		case 4:	g_module_hand_support->RegistHookCallBack((uint8_t*)"+ZMQRCV: 5,",MQTT_Handler_5,0);break;
	}
	_mqtask[mqtaskuserg].id=mqtaskuserg;
	_mqtask[mqtaskuserg].mqtttask=Task;
	
	//mqtaskuserg++;
	//̶id 1
	return mqtaskuserg;
	}
	return 0;
}

uint8_t ZIPOPEN(uint8_t id,char *ipadd,char *ipport)
{
	uint8_t rxtemp[512]={0};
	info("AT+ZIPOPEN=%d,0,%s,%s\r\n",id,ipadd,ipport);
	module_printf("AT+ZIPOPEN=%d,0,%s,%s\r\n",id,ipadd,ipport);
	if(ModuleBlockingRead((char*)rxtemp,15000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
					memset(rxtemp,0,512);
					if(ModuleBlockingRead((char*)rxtemp,15000))
					{
							uint8_t Proofreading[15]={0};
							sprintf((char*)Proofreading,"+ZIPSTAT: %d,1",id);
							/*յ +ZIPSTAT: x,1 óɹ*/
							if(my_strstr((char*)rxtemp,(char*)Proofreading))
							{
								info("TCP");
								return 1;
							} else return 0;
							
							return 1;
						}
		}else info("ZIPOPENԭģ%s",rxtemp);
		return 0;
	}else info("ZIPOPENʱ");
	
	return 0;
}

uint8_t ZIPCREATE(uint8_t id)
{
	uint8_t rxtemp[512]={0};
	info("AT+ZIPCREATE=%d\r\n",id);
	module_printf("AT+ZIPCREATE=%d\r\n",id);
	
	if(ModuleBlockingRead((char*)rxtemp,10000))
	{
		if(my_strstr((char*)rxtemp,"CONNECT"))
		{
			info("ѽ͸ģʽ");
			return 1;
		}else
		{
			info("͸ģʽģʽʧ");
			return 0;
		}
	}else info("ZIPCREATEʱ");
	return 0;
}

uint8_t ZIPCREATE_REMOVE()
{
	uint8_t rxtemp[512]={0};
	info("+++");
	module_printf("+++");
	
	if(ModuleBlockingRead((char*)rxtemp,5000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
			info("˳͸ģʽ");
			return 1;
		}
		else 
		{
			info("˳ʧ");
			return 0;
		}
	}else info("ZIPCREATE_REMOVEʱ");
	return 0;
}

uint8_t ZIPCLOSE(uint8_t id)
{
	uint8_t rxtemp[512]={0};
	
	info("AT+ZIPCLOSE=%d\r\n",id);
	module_printf("AT+ZIPCLOSE=%d\r\n",id);
	
	if(ModuleBlockingRead((char*)rxtemp,15000))
	{
		if(my_strstr((char*)rxtemp,"OK"))
		{
				memset(rxtemp,0,512);
			
				if(ModuleBlockingRead((char*)rxtemp,5000))
				{

							uint8_t Proofreading[15]={0};
							sprintf((char*)Proofreading,"+ZIPSTAT: %d,0",id);
							/*յ +ZIPSTAT: x,1 óɹ*/
							if(my_strstr((char*)rxtemp,(char*)Proofreading))
							{
								info("ѹر%d TCPͨ",id);
								return 1;
							} else return 0;
					
				}
		}else 
		{
			info("ZIPCLOSE ԭ:%s",rxtemp);
		return 0;
		}
	}else info("ZIPCLOSE ʱ");
	return 0;
}

uint8_t CONNECT_PENET_TCP(uint8_t id,char *ipadd,char*ipport)
{
	if(id==0||ipadd==0||ipport==0) return 0;
	
	for(int i=0;i<2;i++)
	{
		 	if(ZIPOPEN(id,ipadd,ipport))
			{
				if(ZIPCREATE(1))
				{
					info("ѳɹ͸TCP");
					/*óɹ򷵻*/
					return 1;
				}else
				{
				}
			}
			
			/*ûóɹ*/
			if(ZMQDISCON(1))
			{
						/**/
				info("³");
				continue;
			}else
			{
				/*ȥͨʧܣ˳͸ģʽ*/
				ZIPCREATE_REMOVE();
			}
	}
	return 0;
}