#include "stdio.h"
#include "string.h"
#include "serialport.h"	/*ͷļ*/

/*λõĹ̼ϢĴ洢͹*/
#include "stmflash.h"
#include "data_manage.h"

_FLASH  flash;

/*עռ*/
Data_register data_map[map_length]=
{
	{TCPADD1, TCPADD1LEN,_string},	
	{TCPPORT1	,TCPPORT1LEN,_string},	
	{TCPADD2,TCPADD2LEN,_string},	
	{TCPPORT2,TCPPORT2LEN,_string},	
	{TCPRESGIPACK,TCPRESGIPACKLEN,_string},
	{TCPHEART,TCPHEARTLEN,_string},
	{TCPHEARTTIME,TCPHEARTTIMELEN,_string},
	{DTUOPENLOG,DTUOPENLOGLEN,_string},
	{DTUID	,DTUIDLEN,_string},
};

void Flash_init(void)
{
	flash.Save=Save_data;
	flash.Read=Read_data;
}

/*ע,mapͼ*/
typedef struct
{
	uint16_t data_id;
	/*Ԥ滮󳤶*/
	uint16_t max_length;
	/*ʵʳ*/
	uint16_t save_length;
	/*ʼַ*/
	uint32_t address;
//	/*͵ID*/
//	uint16_t type_id;
	
}data_information;

///*ע,mapͼ*/
//typedef struct
//{

//	uint16_t map_length;
//	/*ʵʳ*/
//	uint16_t save_length;
//	/*ʼַ*/
//	uint32_t address;
////	/*͵ID*/
////	uint16_t type_id;
//	
//}map_information;

uint8_t Save_data(uint16_t id,void *data,int length)
{
	
	uint32_t temp[512];
	memset(temp,0,512);
	
	STMFLASH_Read(SAVE_ADD_BASE,(uint16_t*)temp,1024);	//ַָʼָȵ

	uint32_t* addr=(uint32_t*)temp;
	
	for(int i=0;i<map_length;i++)
	{
		/*ӦID*/
		if(data_map[i].data_id==id)
		{
			if(data_map[i].type_id!=3)
			{
					if(length>data_map[i].length)
					{
						info("length error");
						return 0;
					}
					/*洢λ*/
					*(uint32_t*)((uint32_t*)(addr))=length;
					
					for(int n=0;n<data_map[i].length&&n<length;n++)
					{
					*(uint32_t*)((uint32_t*)(addr)+n+1)=(((uint32_t*)data)[n]);
					
					}
					break;	
			}/*id3ַ*/
			else if(data_map[i].type_id==3)
			{
					if(length/4>data_map[i].length)
					{
						info("length error");
						return 0;
					}
					/*洢charλ*/
					*(uint32_t*)((uint32_t*)(addr))=length;
					//info("length:%d",length);
					for(int n=0;n<length&&n<data_map[i].length;n++)
					{		
					*((uint8_t*)(addr)+(n+1)*4)=	*((uint8_t*)(data)+n*4);
					*((uint8_t*)(addr)+(n+1)*4+1)=	*((uint8_t*)(data)+n*4+1);
					*((uint8_t*)(addr)+(n+1)*4+2)=	*((uint8_t*)(data)+n*4+2);
					*((uint8_t*)(addr)+(n+1)*4+3)=	*((uint8_t*)(data)+n*4+3);
					}
					
			break;		
			}
			//info("i:%d",i);

		}
		/*ַƫ*/
		addr+=(data_map[i].length+1);
	}	
	//info("%d",(uint32_t)*temp);
	STMFLASH_Write(SAVE_ADD_BASE,(uint16_t*)temp,1024);	
	return 1;
}

uint8_t  Read_data(uint16_t id,void* data)
{
	uint32_t temp[512];
	memset(temp,0,512);
	
	int len=0;
	
	STMFLASH_Read(SAVE_ADD_BASE,(uint16_t*)temp,1024);   		//ַָʼָȵ

	uint32_t* addr=temp;
	
	for(int i=0;i<map_length;i++)
	{
		
		if(data_map[i].data_id==id)
		{
			memset((uint32_t*)data,0,data_map[i].length);
			/*ȡ*/
			len=*(uint32_t*)((uint32_t*)(addr));
			
					if(data_map[i].type_id==3)
					{
									for(int n=0;n<len&&n<data_map[i].length;n++)
									{
									*((uint8_t*)(data)+n*4)=	*((uint8_t*)(addr)+n*4+4);
									*((uint8_t*)(data)+n*4+1)=	*((uint8_t*)(addr)+n*4+5);
									*((uint8_t*)(data)+n*4+2)=	*((uint8_t*)(addr)+n*4+6);
									*((uint8_t*)(data)+n*4+3)=	*((uint8_t*)(addr)+n*4+7);	
									}	
					}
					else
					{
					
						for(int n=0;n<data_map[i].length;n++)
						{
					  *((uint32_t*)(data)+n)=*((uint32_t*)(addr)+n+1);
						//(uint32_t)*(addr+i*4);
						//	info("data:%d",*(uint32_t*)((uint32_t*)(addr)+n+1));
						}
					}
		
			break;
		}
		/*ַƫ*/
		addr+=(data_map[i].length+1);
	}		
	return len;
}

//uint8_t Save_Map(Data_register data_map[],uint8_t length)
//{

//	uint8_t temp[2048];
//	
//	uint16_t deviation=0;
//	
//	for(int i;i<length;i++)
//	{
//		
//		
//	}
//	
//	
//}



///*ע*/

//Data_information Data[]={


//};


//uint8_t Refresh_data()
//{
//	
//	
//	
//}


//typedef struct 
//{
//	
//	Data_information
//	
//	
//	
//	
//}Data_registry;

