/* ******************************************************************************
 * @file    ME3616.c
 * @author  δ DOIOT
 * @brief   EC20ģATָ״
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 *******************************************************************************
 */
 

#ifndef __STMFLASH_H__
#define __STMFLASH_H__
#include "main.h"
extern void  FLASH_PageErase(uint32_t PageAddress); /*ústm32⺯ʵ*/

typedef __IO uint16_t vu16;
typedef __IO uint32_t vu32;

#define STM32_FLASH_SIZE 	128 	 		//ѡSTM32FLASHС(λΪK)
#define STM32_FLASH_WREN 	1              	//ʹFLASHд(0;1ʹ)
#define FLASH_WAITETIME  	50000          	//FLASHȴʱʱ

//FLASHʼַ
#define STM32_FLASH_BASE 0x08000000 		//STM32 FLASHʼַ

uint8_t STMFLASH_GetStatus(void);				  //״̬
uint8_t STMFLASH_WaitDone(uint16_t time);				  //ȴ
uint8_t STMFLASH_ErasePage(uint32_t paddr);			  //ҳ
uint8_t STMFLASH_WriteHalfWord(uint32_t faddr, uint16_t dat);//д
uint16_t STMFLASH_ReadHalfWord(uint32_t faddr);		  //  
void STMFLASH_WriteLenByte(uint32_t WriteAddr,uint32_t DataToWrite,uint16_t Len);	//ַָʼдָȵ
uint32_t STMFLASH_ReadLenByte(uint32_t ReadAddr,uint16_t Len);						//ַָʼȡָ
void STMFLASH_Write(uint32_t WriteAddr,uint16_t *pBuffer,uint16_t NumToWrite);		//ַָʼдָȵ
void STMFLASH_Read(uint32_t ReadAddr,uint16_t *pBuffer,uint16_t NumToRead);   		//ַָʼָȵ

void Flash_Write_String(uint32_t WriteAddr,char *string);										/*дַ*/
void Flash_Read_String(uint32_t ReadAddr,char string[]);										/*ȡַ*/

void Flash_Write_u32(uint32_t WriteAddr,uint32_t arry[],uint32_t length);/*д	u32*/
void Flash_Write_u16(uint32_t WriteAddr,uint16_t arry[],uint32_t length);/*д	u16*/
void Flash_Write_u8(uint32_t WriteAddr,uint8_t arry[],uint32_t length);	/*д	u8*/
void Flash_Read_u32(uint32_t ReadAddr,uint32_t arry[],uint32_t length);	/*	u32*/
void Flash_Read_u16(uint32_t ReadAddr,uint16_t arry[],uint32_t length);	/*	u16*/
void Flash_Read_u8(uint32_t ReadAddr,uint8_t arry[],uint32_t length);		/*	u8*/
void Flash_And_Read_Test(void);/*Զд*/
#endif

















