/* Includes ------------------------------------------------------------------*/
#include "dtu.h"

#include "stdio.h"
#include "string.h"

#include <stdarg.h>		
#include <stdlib.h>		

#include "data_manage.h"


#include "iwdg.h"
#include "usart.h"
#include "wwdg.h"
#include "gpio.h"

#include "serialport.h"	/*ͷļ*/
#include "gm190_library.h"
#include "malloc.h"	

#include "at_module.h"

/* Includes ------------------------------------------------------------------*/
/*͸־*/

/*ƿر־*/
extern uint8_t  ledMode;

/*ģ鿪״̬־*/
uint8_t MODULE_POWER_FLUG=0;

/*MQTT߱־*/
uint8_t TCP_ONLINE_FLUG=0;
/*ģʽı־*/
uint8_t DTU_CONFIG_FLUG=0;
/*ģ״̬λ*/
uint8_t TCP_NET_FLUG=0;

/*ģ쳣״̬־*/
uint8_t ALL_ABNORMAL_FLUG=0;

/*״̬־*/
uint8_t net_sign=9;

/* mqttӲ ------------------------------------------------------------------*/
char * g_TCPADD1=0;
char * g_TCPPORT1=0;
char * g_TCPADD2=0;
char * g_TCPPORT2	=0;
char * g_TCPRESGIPACK=0;
char * g_TCPHEART=0;
char * g_TCPHEARTTIME=0;
char * g_DTUOPENLOG=0;
char * g_DTUID=0;
/* Includes ------------------------------------------------------------------*/

uint8_t TCP_TASK()
{
		/*.*/
	if(net_sign!=3)
	{
		/*ȵ*/
		ModuleWaitNet(1);
	}else
	{
	}
			
	if(CONNECT_PENET_TCP(1,g_TCPADD1,g_TCPPORT1)==0) 
	return 0;
	
	return 1;
}

/**/
void TCP_LOOP()
{
	/*ÿ*/
	if(MODULE_POWER_FLUG==0)return ;
	/*פ*/
	if(TCP_NET_FLUG==0) return;
	
	if(!TCP_ONLINE_FLUG)
	{
		
	if(TCP_TASK())
	{
		/**/	
	TCP_ONLINE_FLUG=1;	
	
	debug_printf(g_DTUOPENLOG);
		
	info("");	
	}else
	{
		info("ʧ");
	}
	}
}

uint8_t TCP_OUTLINE(uint8_t *message,uint16_t length)
{
	info("鵽");
	TCP_ONLINE_FLUG=0;	
	ledMode=2;
	return 1;
}


uint8_t ENABLE_POWER=1;

uint8_t MODULE_POWER_LOOP()
{
	//debug_printf("ʼ");
	/*ÿ*/
	if(MODULE_POWER_FLUG==0)
	{
		/**/
		while(!OPEN_MODULE(1));
		MODULE_POWER_FLUG=1;
		return 1;
	}
	return 1;
}

uint8_t MODULE_NET_LOOP()
{
	/*ÿֱӷ*/
	if(MODULE_POWER_FLUG==0)return 0;
	
	/*ûפ*/
	if(TCP_NET_FLUG==0)
	{
		/**/
		ModuleWaitNet(1);
		TCP_NET_FLUG=1;
		return 1;
	}
	return 0;
}


/*ѯ߷*/
uint8_t LOOP_QUERRY_MQTT(void)
{
	/*ÿ*/
	if(MODULE_POWER_FLUG==0) return 0;
	if(TCP_NET_FLUG==0) return 0;
	
	/*־Ϊ1״̬ѯѯΪæ*/
	if(TCP_ONLINE_FLUG)
	{
		/**/
		if(ZMQSTART(1))
		{
			info("\r\n");
			return 1;
		}
		else
		{
			/*,ֶ߱־λ*/	
			TCP_ONLINE_FLUG=0;
			
			/*һ״̬*/
			switch(ModuleWaitNet(0))
			{
				case 0: info("PIN"); net_sign=0;TCP_NET_FLUG=0;break;
				case 1:	info("CEREG"); net_sign=1;TCP_NET_FLUG=0;break;
				case 2:	info("CALL");net_sign=2; TCP_NET_FLUG=0;break;
				case 3:	info(""); net_sign=3;TCP_NET_FLUG=0;break;
			}
			
			info("\r\n");
			return 0;
		}
	}
	return 1;
}

/*---------------------------------------------------------------------------------------------------*/
uint8_t ALL_CONFIG(char *message);
uint8_t QUEERY_ALL(uint8_t flug);

void GetCMD(char *cmd)
{
	uint8_t temp[124]={0};
	GetString_StartEnd((char*)cmd,(char*)temp,"\"",1,2);
	my_strcpy((char*)cmd,(char*)temp);
}
void SAVE_CONFIGDATA(uint8_t id,char *message)
{
		GetCMD(message);
	  flash.Save(id,message,my_strlen((char*)message));	
}
void READ_CONFIGDATA(uint8_t id,char *data)
{
	  flash.Read(id,data);	

}
/*----------------------------------------------------------------------------------------------------------*/
uint8_t CONFIG_Instruction(uint8_t *message,uint16_t length)
{
	//static uint8_t CONFIG_MODE=0;
	if(my_strstr((char*)message,"CONFIG:doiot"))
	{
		debug_printf("\r\nCONFIG_MQTTALY\r\n");	
		DTU_CONFIG_FLUG=1;
		ledMode=1;
	}else 
	{
		
		ALL_CONFIG((char *)message);
	}
  return 1;
}

uint8_t ALL_CONFIG(char *message)
{
	if(my_strstr(message,"CONFIGTCPADD1:"))							//CONFIGMQTTADD:
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPADD1,message);
		debug_printf("CONFIGTCPADD1:OK\n");
		
	}else if(my_strstr(message,"CONFIGTCPPORT1:"))			//CONFIGMQTTPORT:
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPPORT1,message);	
		debug_printf("CONFIGTCPPORT1:OK\n");
	}else if(my_strstr(message,"CONFIGTCPADD2:"))			  //CONFIGMQTTPID:
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPADD2,message);	
		debug_printf("CONFIGTCPADD2:OK\n");
		
	}else if(my_strstr(message,"CONFIGTCPPORT2:"))			  //CONFIGMQTTPID:
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPPORT2,message);	
		debug_printf("CONFIGTCPPORT2:OK\n");
		
	}else if(my_strstr(message,"CONFIGTCPRESGIPACK:"))			//CONFIGMQTTDID
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPRESGIPACK,message);	
		debug_printf("CONFIGTCPRESGIPACK:OK\n");
		
		}else if(my_strstr(message,"CONFIGTCPHEART:"))			//CONFIGMQTTDSE
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPHEART,message);	
		debug_printf("CONFIGTCPHEART:OK\n");
		
	}else if(my_strstr(message,"CONFIGTCPHEARTTIME"))		//CONFIGMQTTHEART
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(TCPHEARTTIME,message);	
		debug_printf("CONFIGTCPHEARTTIME:OK\n");
	
	}else if(my_strstr(message,"CONFIGDTUOPENLOG:"))		//CONFIGMQTTHAEARTTIME
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(DTUOPENLOG,message);	
		debug_printf("CONFIGDTUOPENLOG:OK\n");
		
	}else if(my_strstr(message,"CONFIGDTUID:"))			//CONFIGMQTTSUB
	{
		  /*ȡָ*/
		SAVE_CONFIGDATA(DTUID,message);	
		debug_printf("CONFIGDTUID:OK\n");
	}
	else if(my_strstr(message,"CONFIGOVER"))
	{
		
		NVIC_SystemReset();
		
	}else if(my_strstr(message,"CONFIGRESET"))
	{
		NVIC_SystemReset();
		
		
	}else if(my_strstr(message,"CONFIGMQUEERY"))
	{
		QUEERY_ALL(0);
	}else if(my_strstr(message,"CONFIGCLOSEMUDULE"))
	{
		
	}
	return 1;
}

//char * g_TCPADD1=0;
//char * g_TCPPORT1=0;
//char * g_TCPADD2=0;
//char * g_TCPPORT2	=0;

uint8_t QUEERY_ALL(uint8_t flug)
{
	char temp[512];
	memset(temp,0,512);
	
	if(flug) 
	{

	}
	else debug_printf("DTUEDIT:\"DOIOT DTU V1.0\"\n");
	
	
	READ_CONFIGDATA(TCPADD1,temp);
	if(flug) 
	{
		g_TCPADD1=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPADD1,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPADD1,(char*)temp);
		info("TCPADD1:\"%s\"",g_TCPADD1);
	}
	else debug_printf("TCPADD1:\"%s\"\n",temp);
	
	READ_CONFIGDATA(TCPPORT1,temp);
	if(flug) 
	{
		g_TCPPORT1=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPPORT1,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPPORT1,(char*)temp);
		info("TCPPORT1:\"%s\"",temp);
	}
	else debug_printf("TCPPORT1:\"%s\"\n",temp);
	
	
	READ_CONFIGDATA(TCPADD2,temp);
	if(flug) 
	{
		g_TCPADD2=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPADD2,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPADD2,(char*)temp);
		info("TCPADD2:\"%s\"",g_TCPADD2);
	}else
	debug_printf("TCPADD2:\"%s\"\n",temp);
	
	READ_CONFIGDATA(TCPPORT2,temp);
	if(flug) 
	{
		g_TCPPORT2	=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPPORT2,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPPORT2	,(char*)temp);
		info("TCPPORT2:\"%s\"",g_TCPPORT2	);
	}
	else 	debug_printf("TCPPORT2:\"%s\"\n",temp);
	
	READ_CONFIGDATA(TCPRESGIPACK,temp);
	if(flug) 
	{
		g_TCPRESGIPACK=malloc(my_strlen((char*)temp)+1);
		ReplaceSpace(temp);
		memset(g_TCPRESGIPACK,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPRESGIPACK,(char*)temp);
		info("TCPRESGIPACK:\"%s\"",g_TCPRESGIPACK);
	}
	else debug_printf("TCPRESGIPACK:\"%s\"\n",temp);
	
	
	READ_CONFIGDATA(TCPHEART,temp);
	if(flug) 
	{
		g_TCPHEART=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPHEART,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPHEART,(char*)temp);
		info("TCPHEART:\"s\"",g_TCPHEART);
	}else
	debug_printf("TCPHEART:\"%s\"\n",temp);
	
	READ_CONFIGDATA(TCPHEARTTIME,temp);
	if(flug) 
	{
		g_TCPHEARTTIME=malloc(my_strlen((char*)temp)+1);
		memset(g_TCPHEARTTIME,0,my_strlen((char*)temp)+1);
		my_strcpy(g_TCPHEARTTIME,(char*)temp);
		info("TCPHEARTTIME:\"%s\"",g_TCPHEARTTIME);
	}else
	debug_printf("TCPHEARTTIME:\"%s\"\n",temp);
	
	READ_CONFIGDATA(DTUOPENLOG,temp);
	if(flug) 
	{
		g_DTUOPENLOG=malloc(my_strlen((char*)temp)+1);
		memset(g_DTUOPENLOG,0,my_strlen((char*)temp)+1);
		my_strcpy(g_DTUOPENLOG,(char*)temp);
		info("DTUOPENLOG:\"%s\"",g_DTUOPENLOG);
	}else
	debug_printf("DTUOPENLOG:\"%s\"\n",temp);

	READ_CONFIGDATA(DTUID,temp);
	if(flug) 
	{
		g_DTUID=malloc(my_strlen((char*)temp)+1);
		memset(g_DTUID,0,my_strlen((char*)temp)+1);
		my_strcpy(g_DTUID,(char*)temp);
		info("DTUID:\"%s\"",g_DTUID);
	}else
	debug_printf("DTUID:\"%s\"\n",temp);
	
	return 1;
}

uint8_t LED_FLASH_FLUG_FOR_TIMEER=0;

void NET_LED_LOOP()
{
	if(DTU_CONFIG_FLUG)
	{
		
	}
	else
	{
	if(TCP_ONLINE_FLUG)
	ledMode=3;
	else ledMode=2;
	}
}

uint8_t live()
{
	if(TCP_ONLINE_FLUG)
	{
		
	if(g_TCPHEART!=0)
	module_printf(g_TCPHEART);	
	
	info("ɹ");
	return 1;
	}
	return 0;
}


uint8_t CLOSE_MUDULE()
{
	
	
	
}


