/** ******************************************************************************
 * @file    String.c
 * @author  δ DOIOT
 * @brief   Թ˾ģATָĴ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 ********************************************************************************/
 
#include "main.h"    

typedef  struct{
	
	uint8_t	 (*Hex_str)(char *ascii_str,char hex_str[]);
	
	uint8_t (*char_2_hex)(char c1,char c2);
	
	uint8_t (*char_2_dec)(char c1,char c2);
	
	uint16_t  (*dec_arry)(char ascii_str[],uint8_t dex_arry[]);
	
	uint16_t  (*hex_arry)(char ascii_str[],uint8_t hex_arry[]);
	
	uint8_t		(*R_CUT)(char *str,char buff[],uint8_t len);
	
	uint8_t		(*L_CUT)(char *str,char buff[],uint8_t len);
	
}TO;

typedef  struct{
	
	uint8_t	 (*Hex_Str)(uint8_t ascii_str[]);
	
	uint8_t  (*Ascii_Str)(uint8_t ascii_str[]);
	
	uint16_t (*dec_arry)(uint8_t ascii_str[]);
	
	uint16_t (*hex_arry)(uint8_t ascii_str[]);
	
	uint8_t  (*R_CUT)(char *str,uint8_t len);
	
	uint8_t  (*L_CUT)(char *str,uint8_t len);
	
	uint8_t  (*L_Shift)(char *str,uint8_t len);
	
}Convert;


typedef struct{
	
	
	uint8_t (*hexStr)(uint8_t arry[],char hex_str[],uint16_t len);

	uint8_t (*decStr)(uint8_t arry[],char dec_str[],uint16_t len);

	uint8_t (*asciiStr)(uint8_t arry[],char dec_str[],uint16_t len);
	
	uint8_t (*R_CUT)(uint8_t arry[],uint8_t arry_len,uint8_t cut_len);

	uint8_t (*L_CUT)(uint8_t arry[],uint8_t arry_len,uint8_t len);
	
}Array;

typedef struct
{
	
	int a;
	
	
}_AT;

typedef  struct{
	
	TO to;
	
	Convert convert;
	
}STR;

void STR_init(STR * st);
void Array_init(Array *ar);
extern STR  Str;
extern Array array;

/**@brief AsciiStr_2_HexStr :	string ascii⣬ת hex ַ
* @param  ascii_str		 : ַ,Ҫ֤нλ
* @param  hex_str	 		 : ɵַ
* :		"stm32f103"   "73746D33326631"
*/
uint8_t AsciiStr_2_HexStr(char *ascii_str,char hex_str[]);
/**@brief str_2_dec_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={32,32,32,32};
*/
uint16_t str_2_dec_arry(char ascii_str[],uint8_t dex_arry[]);

/**@brief str_2_hex_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={0x32,0x32,0x32,0x32};
*/
uint16_t str_2_hex_arry(char ascii_str[],uint8_t hex_arry[]);

/**@brief  char_2_hex:ַ16תһʮƣreturn
* :		char c1='1'  char c2='1'  uint8_t a=11;
*/
uint8_t  char_2_hex(char c1,char c2);
/**@brief  char_2_decַ10תһʮƣreturn
* :		char c1='1'  char c2='1'  uint8_t a=0x11;
*/
uint8_t  char_2_dec(char c1,char c2);
/**@brief R_CUT:ҿülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t R_CUT(char *str,char buff[],uint8_t len);
/**@brief L_CUT:󿿲ülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t L_CUT(char *str,char buff[],uint8_t len);

/**@brief AsciiStr_convert_HexStr:asciiַתhexַ
* @param  ascii_str		 : ַ,ᱻתhexַ
* :		"stm32f103"  "73746D33326631"
*/
uint8_t AsciiStr_convert_HexStr(uint8_t ascii_str[]);

/**@brief str_2_dec_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={32,32,32,32};
*/
uint16_t str_convert_dec_arry(uint8_t ascii_str[]);

/**@brief str_2_hex_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={0x32,0x32,0x32,0x32};
*/
uint16_t str_convert_hex_arry(uint8_t ascii_str[]);
/**@brief AsciiStr_convert_HexStr:asciiַתhexַ
* @param  ascii_str		 : ַ,ᱻתhexַ
* :		"73746D33326631"    "stm32f103"  
*/
uint8_t HexStr_convert_AsciiStr(uint8_t ascii_str[]);
/**@brief R_CUT:ҿülenbuff,ֱӸıԭ
*/
uint8_t Convert_R_CUT(char *str,uint8_t len);
/**@brief L_CUT:󿿲ülenbuffֱӸıԭ
*/
uint8_t Convert_L_CUT(char *str,uint8_t len);
/**@brief Shift_left:ַƣֱӸıԭ
*/
uint8_t Shift_left(char *str,uint8_t len);
/*----------------------------------------------------------------------------------*/

/**@brief Arry_2_hexstr :	8λ鰴ת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ

* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "32323232"
*/
uint8_t Arry_2_hexstr(uint8_t arry[],char hex_str[],uint16_t len);
/**@brief Arry_2_decstr :	8λ鰴ת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ

* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "32323232"
*/
uint8_t Arry_2_decstr(uint8_t arry[],char dec_str[],uint16_t len);
/**@brief Arry_2_AsciiStr :	8λ鰴asciiת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ

* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "2222"
*/
uint8_t Arry_2_AsciiStr(uint8_t arry[],char dec_str[],uint16_t len);
/**@brief R_CUT:ҿülenbuff
*/
uint8_t Arry_R_CUT(uint8_t arry[],uint8_t arry_len,uint8_t cut_len);
/**@brief L_CUT:󿿲ülenbuff
*/
uint8_t Arry_L_CUT(uint8_t arry[],uint8_t arry_len,uint8_t len);


