/********************************************************************************
 * @file    debug_module.c
 * @author  δ DOIOT
 * @brief   Թ˾ģATָĴ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾1.3		ʱ2020/10/15   ļ֮϶
********************************************************************************/
#include "serialport.h"
#include "debug_module.h"

#include "debug_task.h"

#include "stdarg.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h" 

/*ṹӦָָͷһصǿУںн*/
struct AT_Config
{
	/*ҪӦָ*/
	char *response_command;
	/*ҪӦĴָ*/
	void (*handle)(char *str);
	
};
/*ṹļ*/
struct Task_Arry
{
	struct	AT_Config *at_cmd;
	int  		cmdlength;
};	

/*ע,ĬϿһ*/
struct AT_Config at_cmd[]={{"AT+CoNfIg",ConfigMode},
//													 {"AT+CoNfIg=0",task2},
//													 {"AT+CLOSE",task2}
													};
/*ע2飬ΪּTask_positionΪл־*/
struct AT_Config at_cmd_2[]={{"AT+CoNfIg=",ConfigMode},
														 {"AT+QUERY=",QUERY_TASK},
														 {"AT+TCPADDR1=",TCP_ADDRESS_1},
													   {"AT+TCPADDR2=",TCP_ADDRESS_2},
													   {"AT+DTUID=",DTU_ID},
														 {"AT+TCPREGIS_PACK=",TCP_REGIST_Pack},
														 {"AT+TCPHEART_PACK=",TCP_HEART_Pack},
														 {"AT+DTUSTART_LOG=",START_DTU_LOG},
														 {"AT+TCPHEART_TIME=",TCP_HEART_TIME},
														 
														 {"AT+MQADD=",MQTT_ADD},
														 {"AT+MQPORT=",MQTT_PORT},
														 {"AT+MQPID=",MQTT_PID_},
														 {"AT+MQDID=",MQTT_DID_},
														 {"AT+MQDSE=",MQTT_DSE_},
														 {"AT+MQHEART=",MQTT_HAEART_},
														 {"AT+MQHEART_TIME=",MQTT_HAEART_TIME_},
														 {"AT+MQSUB=",MQTT_SUB_},
														 {"AT+MQPUB=",MQTT_PUB_},
													};

/*ͬϢ*/
struct AT_Config at_cmd_config[]={
														 {"AT+CoNfIg",ConfigMode},
														 {"AT+QUERY",QUERY_TASK},
														 {"AT+TCPADDR1",TCP_ADDRESS_1},
													   {"AT+TCPPORT2",task5},
													   {"AT+DTUID",DTU_ID},
														 {"AT+SAVE",DTU_ID},
														 {"AT+TCPMODE",DTU_ID}
													};
/*洢ջ*/
struct 		Task_Arry Task_Array[3]={{at_cmd,1},
																	{at_cmd_2,18},
																	{at_cmd_config,7}
																};
/*洢λõı־Ϊ0ָһ飬ڳ޸ָл*/
uint16_t   Task_position=0;  
																
																
/**
* @brief AT_Register: ATעắ
* @param cmd_arry	: ҪУӦ
* @param ack_str: ӦУִ
* @param overtime	: 
*/

uint8_t AttentionResponseInit()
{
	return 1;
}
/**
* @brief AttentionResponse: עִ
* @param ָܵcmd	: ҪУӦ
*/													
uint8_t  AttentionResponse(char *cmd,uint16_t cmd_len)		
{	
		/*У,ͼ*/
		if(*cmd=='A')
		{
			if(*(cmd+1)=='T')/*У,ͼ*/
			{
				if(*(cmd+cmd_len-2)=='\r'&&*(cmd+cmd_len-1)=='\n')/*ATָʼ*/
				{
					if(CommandResponse(cmd))
					return 1;
					else return 0;
				}else
				{
					//debug_printf("%d,%d",*(cmd+cmd_len-2),*(cmd+cmd_len-1));
					return 0;
				}
			}
			else return 0;
		}
		else 
		{
			return 0;
		}
}	
													
/**
* @brief CommandResponse: עִ
* @param ָܵcmd	: ҪУӦ
* ڲ
*/
uint8_t  CommandResponse(char *cmd)
{
	int cmd_len=Task_Array[Task_position].cmdlength;
	
	for(int i=0;i<cmd_len;i++)
	{

		if(strstr(cmd,Task_Array[Task_position].at_cmd[i].response_command))
		{
			if(Task_Array[Task_position].at_cmd[i].handle!=NULL)
			Task_Array[Task_position].at_cmd[i].handle(cmd);
			return 1;
		}
	}
	return 0;
}
