/** ******************************************************************************
 * @file    String.c
 * @author  δ DOIOT
 * @brief   Թ˾ģATָĴ
 ******************************************************************************
 * @attention
 * <h2><center>&copy; Copyright (c) 2019 ɶδ
 * All rights reserved.</center></h2>
 * ע:cubemx ɵhalٿ
 * :keil5.0
 * STM32Cube FW_F1 V1.8.0
 * ļ汾1.3		ʱ2020/10/15   ܶຯдòԣbugһС
 ********************************************************************************/
#include "string_fuc.h"
#include "stdarg.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h" 

//#include "serialport.h"		/*ڽṹģ*/
//#include "AT_Module.h"		 /*ATָصͷļ*/


/*--------------------------------ü[Ե,ʹܺԶһȫʵ]----------------------------------------------*/

#define  config_String_process							1
#define  config_Array_process								1

/*--------------------------------[stringַĴ]----------------------------------------------

	  char str[],uint8_t arry[]һģǱļⲻֳͬstringַarry
	
		ʹõַɷ֣ʹsrrʹݳɷ֣ʹarry


char str[]="32323232" ---> uint8_t arry={0x32,0x32,0x32,0x32};
string ݰ16⣬ת 8λ arry
str_2_hex_arry;

char str[]="32323232" ---> uint8_t arry={32,32,32,32};
string ݰ10⣬ת 8λ arry
str_2_dec_arry;

char "3" char "2" 		---> uint8_t  i=0x32;
ַʮϳһ8λʮƱ
 char_2_hex

char "3" char "2"  		--->  uint8_t  i=32;
ַʮ,ϳһ8λʮƱ
 char_2_dec

char str[]="stm32f103" --->   char str[]="73746D33326631"
string ݰascii⣬תʮƱʾstring
AsciiStr_2_HexStr;

*----------------------------------[arryַĴ]----------------------------------------------*/
/*
Arry

uint8_t arry={0x32,0x32,0x,32,0x32};  "32323232"
8λÿλһת16Ʊʾstring
arry_2_hexstr;

---------------------------------------------------------------------------------*/

/*stringľ*/
#if(config_String_process) 
 STR   Str;
#endif
#if(config_Array_process)
 Array array;
#endif
 
#if(config_String_process) 
/**@brief AsciiStr_2_HexStr :	string ascii⣬ת hex ַ
* @param  ascii_str		 : ַ,Ҫ֤нλ
* @param  hex_str	 		 : ɵַ
* :		"stm32f103"   "73746D33326631"
*/
uint8_t AsciiStr_2_HexStr(char *ascii_str,char hex_str[])
{
			char hex[3]={0};	
			memset(hex,0,3);
			uint16_t i;
			for(i=0;i<strlen(ascii_str);i++)
			{
			sprintf(hex,"%02x",ascii_str[i]);
			strcat(hex_str,hex);		
			}
			return 1;
}



/**@brief str_2_dec_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={32,32,32,32};
*/
uint16_t str_2_dec_arry(char ascii_str[],uint8_t dex_arry[])
{
			uint16_t len=strlen(ascii_str)*2;
			char hex_str[len+2];
			memset(hex_str,0,len);
	
			char hex[3]={0};	
			memset(hex,0,3);
			uint16_t i;
			uint16_t n;
			for(i=0;i<len/2;i++)
			{
				hex[0]=ascii_str[i*2];
				hex[1]=ascii_str[i*2+1];
				n=atoi(hex);
				dex_arry[i]=n;	
			}
			return i+1;
}

/**@brief str_2_hex_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={0x32,0x32,0x32,0x32};
*/
uint16_t str_2_hex_arry(char ascii_str[],uint8_t hex_arry[])
{
			uint16_t len=strlen(ascii_str)*2;
			char hex_str[len+2];
			memset(hex_str,0,len);
	
			char hex[3]={0};	
			memset(hex,0,3);
			uint16_t i;
			uint16_t n;
			for(i=0;i<len/2;i++)
			{
				hex[0]=ascii_str[i*2];
				hex[1]=ascii_str[i*2+1];
				n=strtol(hex, NULL, 16);
				hex_arry[i]=n;	
			}
			return i+1;
}

/**@brief  char_2_hex:ַ16תһʮƣreturn
* :		char c1='1'  char c2='1'  uint8_t a=11;
*/
uint8_t  char_2_hex(char c1,char c2)
{
			char hex[3]={0};
			hex[0]=c1;
			hex[1]=c2;
			uint16_t i= strtol(hex, NULL, 16);
			
			return i;
}
/**@brief  char_2_decַ10תһʮƣreturn
* :		char c1='1'  char c2='1'  uint8_t a=0x11;
*/
uint8_t  char_2_dec(char c1,char c2)
{
			char hex[3]={0};
			hex[0]=c1;
			hex[1]=c2;
			
			return atoi(hex);
}

/**@brief R_CUT:ҿülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t R_CUT(char *str,char buff[],uint8_t len)
{
		uint16_t length=strlen(str);
		if(length>=len)
		{
			strncpy(buff,str+(length-len),len);
			return 1;
		}
		

		return 0;	
}
/**@brief L_CUT:󿿲ülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t L_CUT(char *str,char buff[],uint8_t len)
{
		uint16_t length=strlen(str);
		if(length>=len)
		{
			strncpy(buff,str,len);
			return 1;
		}
		return 0;	
}



/**@brief AsciiStr_convert_HexStr:asciiַתhexַ
* @param  ascii_str		 : ַ,ᱻתhexַ
* :		"stm32f103"  "73746D33326631"
*/
uint8_t AsciiStr_convert_HexStr(uint8_t ascii_str[])
{
			uint16_t len=strlen((char*)ascii_str);
			char hex_str[len*2+2];
			memset(hex_str,'\0',len*2+2);
			

	
			char hex[3]={0};	
			uint16_t i;
			for(i=0;i<len;i++)
			{
			sprintf(hex,"%02x",ascii_str[i]);
			strcat(hex_str,hex);		
			}
			strcpy((char*)ascii_str,hex_str);
			return 1;
}

/**@brief AsciiStr_convert_HexStr:asciiַתhexַ
* @param  ascii_str		 : ַ,ᱻתhexַ
* :		"73746D33326631"    "stm32f103"  
*/
uint8_t HexStr_convert_AsciiStr(uint8_t ascii_str[])
{
			uint16_t len=strlen((char*)ascii_str);
			char hex_str[len/2+2];
			memset(hex_str,'\0',len/2+2);

			char hex[3]={0};	
			char ascii[2]={0};
			uint16_t i;
			int vlue=0;
			for(i=0;i<len;i+=2)
			{
			hex[0]=ascii_str[i];
			hex[1]=ascii_str[i+1];
			vlue= strtol(hex, NULL, 16);
			sprintf(ascii,"%c",vlue);
			strcat(hex_str,ascii);		
			}
			strcpy((char*)ascii_str,hex_str);
			return 1;
}


/**@brief str_2_dec_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={32,32,32,32};
*/
uint16_t str_convert_dec_arry(uint8_t ascii_str[])
{
			uint8_t fifo[500];
			uint16_t len=strlen((char*)ascii_str)*2;
			char hex_str[len+2];
			memset(hex_str,0,len);
			
			
			char hex[3]={0};	
			memset(hex,0,3);
			uint16_t i;
			uint16_t n;
			for(i=0;i<len/2;i++)
			{
				hex[0]=ascii_str[i*2];
				hex[1]=ascii_str[i*2+1];
				n=atoi(hex);
				fifo[i]=n;	
			}
			memcpy(ascii_str,fifo,i);
			return i+1;
}

/**@brief str_2_hex_arry:string ݰ10⣬ת 8λ arry
*  @param  ascii_str		 : ַ,ᱻתhexַ
* return ᷵س
* :		char s[]="32323232" ---> uint8_t arry={0x32,0x32,0x32,0x32};
*/
uint16_t str_convert_hex_arry(uint8_t ascii_str[])
{
			uint8_t fifo[500];
			uint16_t len=strlen((char*)ascii_str)*2;
			char hex_str[len+2];
			memset(hex_str,0,len);
	
			char hex[3]={0};	
			memset(hex,0,3);
			uint16_t i;
			uint16_t n;
			for(i=0;i<len/2;i++)
			{
				hex[0]=ascii_str[i*2];
				hex[1]=ascii_str[i*2+1];
				n=strtol(hex, NULL, 16);
				fifo[i]=n;	
			}
			memcpy(ascii_str,fifo,i);
			return i+1;
}


/**@brief R_CUT:ҿülenbuff,ֱӸıԭ
*/
uint8_t Convert_R_CUT(char *str,uint8_t len)
{
		
		uint16_t length=strlen(str);
		char buff[length];
		
		if(length>=len)
		{
			strncpy(buff,str+(length-len),len);
			memset(str,0,length);
			strcpy(str,buff);
			return 1;
		}
		

		return 0;	
}
/**@brief L_CUT:󿿲ülenbuffֱӸıԭ
*/
uint8_t Convert_L_CUT(char *str,uint8_t len)
{
		uint16_t length=strlen(str);
		char buff[length];
		if(length>=len)
		{
			strncpy(buff,str,len);
			strcpy(str,buff);
			return 1;
		}
		return 0;	
}

/**@brief Shift_left:ַ,൱ڲüߵļλ
*/
uint8_t Shift_left(char *str,uint8_t len)
{
	int lengtth=strlen(str);
	for(int i=0;i<(lengtth);i++)
	{
		*(str+i)=*(str+len+i);
		if(i>=(lengtth-len))*(str+i)=0; 
	}
	return 1;
}


#endif
/*----------------------------------------------------------------------------------*/
#if(config_Array_process)
/**@brief Arry_2_hexstr :	8λ鰴ת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ
	[עⲿ0]
* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "32323232"
*/
uint8_t Arry_2_hexstr(uint8_t arry[],char hex_str[],uint16_t len)
{
			uint16_t i;
			char hex[3]={0};
			memset(hex_str,0,len*2);
			for(i=0;i<len;i++)
			{
			
			sprintf(hex,"%02x",arry[i]);
			strcat(hex_str,hex);		
			}
			
			return 1;
}
/**@brief Arry_2_decstr :	8λ鰴ת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ

* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "32323232"
*/
uint8_t Arry_2_decstr(uint8_t arry[],char dec_str[],uint16_t len)
{
			uint16_t i;
			char hex[3]={0};
			for(i=0;i<len;i++)
			{
			
			sprintf(hex,"%02d",arry[i]);
			strcat(dec_str,hex);		
			}
			return 1;
}

/**@brief Arry_2_decstr :	8λ鰴ת16Ʊʾַ
* @param  arry		 : 
* @param  hex_str 		 : ɵַ

* :	uint8_t arry={0x32,0x32,0x32,0x32}; ---> "2222"
*/
uint8_t Arry_2_AsciiStr(uint8_t arry[],char dec_str[],uint16_t len)
{
			uint16_t i;
			char hex[3]={0};
			for(i=0;i<len;i++)
			{
			
			sprintf(hex,"%c",arry[i]);
			strcat(dec_str,hex);		
			}
			return 1;
}


/**@brief R_CUT:ҿülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t Arry_R_CUT(uint8_t arry[],uint8_t arry_len,uint8_t cut_len)
{
		
		uint8_t buff[512]={0};
		if(arry_len>=cut_len)
		{
			uint16_t i;
			for(i=cut_len;i<arry_len;i++)
			{
				buff[i]=arry[i];
			}
			memcpy(arry,buff,arry_len);
			return 1;
		}
		

		return 0;	
}
/**@brief L_CUT:󿿲ülenbuffstrΪԭݣ֮ѡһbuffΪ˱ԭ
*/
uint8_t Arry_L_CUT(uint8_t arry[],uint8_t arry_len,uint8_t len)
{
		
		if(arry_len>=len)
		{
			uint16_t i;
			for(i=len;i<arry_len;i++)
			{
				arry[i]=0;
			}
			return 1;
		}

		return 0;	
}
#endif

#if(config_String_process) 
void STR_init(STR * st)
{
	
	st->to.Hex_str=AsciiStr_2_HexStr;
		
	st->to.dec_arry=str_2_dec_arry;
	
	st->to.hex_arry=str_2_hex_arry;
	
	st->to.char_2_dec=char_2_dec;
	
	st->to.char_2_hex=char_2_hex;
	
	st->to.L_CUT=L_CUT;
	
	st->to.R_CUT=R_CUT;
	
	
	st->convert.Hex_Str=AsciiStr_convert_HexStr;
	
	st->convert.Ascii_Str= HexStr_convert_AsciiStr;
	
	st->convert.dec_arry=str_convert_dec_arry;
	
	st->convert.hex_arry=str_convert_hex_arry;
	
	st->convert.L_CUT=Convert_R_CUT;
	
	st->convert.R_CUT=Convert_R_CUT;

	st->convert.L_Shift=Shift_left;
}
#endif

#if(config_Array_process)
void Array_init(Array *ar)
{
	
	ar->hexStr=Arry_2_hexstr;
	
	ar->decStr=Arry_2_decstr;
	
	ar->R_CUT=Arry_R_CUT;
	
	ar->L_CUT=Arry_L_CUT;
	
	ar->asciiStr=Arry_2_AsciiStr;
}
#endif

